# *****************************************
# NAME: makefile
# PROJECT: mophun Tutorials
# DATE: 2002-03-14
# *****************************************
# *****************************************
# FLAGS
#
# Use g to enable debugging
# *****************************************
# STACK AND HEAP
#
# -mstack = 1024    - This is the desired STACK size
# -mdata  = 15000	- This is the desired HEAP size. This is the memory
#			             used when doing memory allocations.
# *****************************************
STACKSIZE	= 3048
HEAPSIZE	= 46080
#CFLAGS		= -02 -Wall
# *****************************************
# OBJEKTFILES
# *****************************************
OBJS		=	globals.o \
				main.o \
				res.o \
				rmg.o \
				utility.o \
				app.o \
				introduction.o \
				title.o \
				about.o \
				loading.o \
				help.o \
				collection.o \
				menu.o \
				game.o \
				inventory.o \
				victory.o \
				gameover.o

all : DungeonKid.mpn

# *****************************************
# RESOURCE
# *****************************************
res.o: res.txt
	morc -v res.txt 

# *****************************************
# COMPILER
# *****************************************
.c.o:
	pip-gcc -c $(CFLAGS) -o $@ $<


# *****************************************
# LINKER
# *****************************************
DungeonKid.mpn: $(OBJS)
	pip-gcc -o $@ $(OBJS) -mstack=$(STACKSIZE) -mdata=$(HEAPSIZE) -s -ldatacert


