#ifndef CINPUTSYSTEM_H
#define CINPUTSYSTEM_H

//#include "includes.h"
#ifdef _MSC_VER
  #include "SDL.h"      //include SDL Header
#else
  #include "SDL/SDL.h"      //include SDL Header
#endif

class CInputSystem
{
public:
	SDL_Event LastEvent;
public:
	CInputSystem();
	~CInputSystem();

	bool UpdateEvents();  //Poll an event and save its results

	//Check if a key is down from the last UpdateEvent(), 
	//key is a value from SYMKey and Extra is a value from SYMMOD, 
	//the Extra is the field where you can check if a key was pressed along with SHIFT, 
	//CRTL, or any other extra key
	bool IsKeyDown(SDLKey key, SDLMod Extra=KMOD_NONE);
	//same as IsKeyDown except that it checks for a key up :)
	bool IsKeyUp(SDLKey key, SDLMod Extra=KMOD_NONE);

};

#endif

