#ifndef FACE_H
#define FACE_H

#include "ImageSystem.h"
#include "includes.h"

class FaceTexture
{
private:
	vector<CImage> AniFrames;
	int FramesPerSec;
	unsigned int CurrentTexture;
public:
	FaceTexture();
	virtual ~FaceTexture();

	bool FrameAdd(char *filename);	//add an image as a frame
	bool FrameAddWAlpha(char *filename, int AR, int AG, int AB);	//add an image as a frame

	bool FrameAddXYWH(char *filename, int x, int y, int w, int h); //add a portion of an image as a frame
	inline void SetFramerate(int fr) {if(fr<0) {fr=0;} FramesPerSec=fr; }; //set the framerate of the animation
	inline int GetFramerate() {return (FramesPerSec);}; //returns the current Frames Per Second of the animation

	bool FrameRemove(int framenum);	//removes a frame from the list

	inline int GetCurrentNumFrames() {return (AniFrames.size());};	//returns the current number of frames that have been added

	void Cleanup();
	bool UpdateTex(float dt);	//update the texture with the delta time or the time between the last and this update
	void BindTexture();			//Bind the current animated texture
	void BindSelTexture(int Frame); //Binds the texture with the given frame number
};

#endif