#ifndef GAME_CORE_H
#define GAME_CORE_H

#include "includes.h"
#include "CGraphicsSystem.h"
#include "CInputSystem.h"
//#include "CSoundSystem.h"

struct InitOptions
{
	int Width;
	int Height;
	int Bpp;
	int Depth;
	char * Title;
	char * Icon;
	bool Fullscreen;
	bool Audio;
};

class CGameCore
{
protected:
	CGraphicsSystem * graphics;
	CInputSystem * input;
//	CSoundSystem * sound;
	bool ShutdownBool;
	int CurrentFrameRate;
public:
	CGameCore();
	virtual ~CGameCore();

	virtual bool Initialize() { return true; };	//Initialize anything
	virtual bool Update(float dt)  { return true; }; //gets the time since the last update and updates everything
	virtual void Render()	{};				//Renders the scene
	virtual void Cleanup()	{};				//Cleans up
	virtual void HandleUserEvents(unsigned int dt) {}; //Handle all game events

	bool Init(InitOptions Options);			//Initialize everything
	int Run();								//Run the game

	inline void Shutdown() { ShutdownBool=true; };	//Shut down game
	void HandleCoreEvents();		//Handle all window messages and anything else not pertaining to the game
};


#endif //GAME_CORE_H

