#ifndef IMAGE_SYSTEM_H
#define IMAGE_SYSTEM_H

#include "il/il.h"
#include "il/ilu.h"
#include "il/ilut.h"
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "includes.h"

class CImage
{
private:
	unsigned int TextureName;
	bool TextureCreated;
public:
	bool LoadImage(char* ImageName);		//loads an image and makes the texture
	bool LoadImageWAlpha(char *ImageName, int AR, int AG, int AB);	//Loads the image with an alpha channel by removing the selected color and then turns it into a texture
	bool LoadImageWAlphaImage(char *ImageName, char *AlphaImageName) {return false;}; //Loads the image with an alpha channel from another black and white image and then turns it into a texture

	bool LoadImageXYWH(char* ImageName, int x, int y, int w, int h, bool LLorigin=false);		//loads a part of the image and makes the texture. The LLorigin varible=if true, then the coordinates given are used from the Lower Left Origin, else the coords are used with the upper left origin

	void DestroyTexture();	//Removes the texture from memory

	void BindTexture();	//Binds this texture with OpenGL
	unsigned int GetTextureToBind();	//returns the address to the texture to bind

	CImage();	//constructor
	virtual ~CImage(); //destructor
};

#endif //IMAGE_SYSTEM_H