#include "main.h"

bool FunnyFaces::Initialize()
{
	if(!AniTex.FrameAdd("./Graphics/bg10.jpg"))
		return false;

	if(!AniTex.FrameAdd("./Graphics/bg1.jpg"))
		return false;
	

	if(!AniTex.FrameAddXYWH("./Graphics/bg2.jpg", 0, 0, 150, 150))
		return false;

	Framerate=1;
	AniTex.SetFramerate(Framerate);

	glEnable(GL_ALPHA_TEST);							//Enable Alpha Test
	glAlphaFunc(GL_GREATER, 0);							//Set Alpha Test Parameters

	return true;
}

bool FunnyFaces::Update(float dt)
{
	return (AniTex.UpdateTex(dt));
}	

void FunnyFaces::HandleUserEvents(unsigned int dt)
{
	static int EscapeBool=0;
	static bool PlusBool=false;
	static bool MinusBool=false;

	if(input->IsKeyDown(SDLK_ESCAPE))
		EscapeBool=1;

	if(input->IsKeyUp(SDLK_ESCAPE))
		if(EscapeBool==1)
		{
			EscapeBool=0;
			Shutdown();
		}

	if(input->IsKeyDown(SDLK_EQUALS))
		PlusBool=true;

	if(input->IsKeyUp(SDLK_EQUALS))
		if(PlusBool==true)
		{
			PlusBool=false;
			Framerate+=1;
			AniTex.SetFramerate(Framerate);
		}

	if(input->IsKeyDown(SDLK_MINUS))
		MinusBool=true;

	if(input->IsKeyUp(SDLK_MINUS))
		if(MinusBool==true)
		{
			MinusBool=false;
			Framerate-=1;
			if(Framerate<0)
				Framerate=0;
			AniTex.SetFramerate(Framerate);
		}
}

void FunnyFaces::Render()
{	
	char FrameRateDisplay[50];
	sprintf(FrameRateDisplay, "Framerate=%d AnimationFramerate=%d", CurrentFrameRate, Framerate);
	SDL_WM_SetCaption(FrameRateDisplay, FrameRateDisplay);  // set the window caption

	glColor3f(1.0f, 1.0f, 1.0f);
	AniTex.BindTexture();

	glBegin(GL_TRIANGLE_FAN);						// Build Quad From A Triangle Strip
		glTexCoord2f(0.0f, 0.0f); glVertex3f(0.0f, 0.0f, 0.0f);
		glTexCoord2f(1.0f, 0.0f); glVertex3f(800.0f, 0.0f, 0.0f);
		glTexCoord2f(1.0f, 1.0f); glVertex3f(800.0f, 600.0f, 0.0f);
		glTexCoord2f(0.0f, 1.0f); glVertex3f(0.0f, 600.0f, 0.0f);
	glEnd();
}
		
void FunnyFaces::Cleanup()
{
	//delete Background;
	AniTex.Cleanup();
}

//----------------------------------------------------------------------------------------------
//Main
//----------------------------------------------------------------------------------------------
int main(int argc, char *argv[]) 
{
	FunnyFaces game;

	InitOptions opt;
	opt.Width=800;
	opt.Height=600;
	opt.Bpp=16;
	opt.Audio=false;
	opt.Fullscreen=false;
	opt.Depth=16;
	opt.Title=(char *)"Funny Faces";
	opt.Icon=NULL;

	game.Init(opt);
	return (game.Run());

	return 0;
}

