#include "about.h"

#include <vmgp.h>
#include "globals.h"
#include "res.h"
#include "utility.h"
#include "app.h"

void about()
{
	uint8_t* resources[NUM_RESOURCES];
	initResources(resources, NUM_RESOURCES);

	LoadPackedRes(MENUBOX, MENUBOX_UNPACKED_SIZE, &resources[MENUBOX]);
	
	vClearScreen(0);
	vDrawObject(width/2 - MENUBOX_WIDTH/2, height/2 - MENUBOX_HEIGHT/2, resources[MENUBOX]);
	uint8_t textX = width/2 - MENUBOX_WIDTH/2 + MENUBOX_START_TEXT_X;
	uint8_t textY = height/2 - MENUBOX_HEIGHT/2 + MENUBOX_START_TEXT_Y;

	vSetForeColor(vRGB(255,0,0));
	vPrint(MODE_TRANS, textX, textY, "DUNGEON KID");		textY += THEFONT_HEIGHT;
	vPrint(MODE_TRANS, textX, textY, "ART AND DESIGN:");	textY += THEFONT_HEIGHT;
	vSetForeColor(255);
	vPrint(MODE_TRANS, textX, textY, "DUSTIN HUBBARD");		textY += THEFONT_HEIGHT;
	vSetForeColor(vRGB(255,0,0));
	vPrint(MODE_TRANS, textX, textY, "PROGRAMMING:");		textY += THEFONT_HEIGHT;
	vSetForeColor(255);
	vPrint(MODE_TRANS, textX, textY, "BRIAN SOWERS");		textY += THEFONT_HEIGHT;
	vSetForeColor(vRGB(255,0,0));
	vPrint(MODE_TRANS, textX, textY, "MUSIC");				textY += THEFONT_HEIGHT;
	vSetForeColor(255);
	vPrint(MODE_TRANS, textX, textY, "JIM PATERSON");		textY += THEFONT_HEIGHT;
	vSetForeColor(vRGB(255,0,0));
	vPrint(MODE_TRANS, textX, textY, "SPOOKYTORNADO.COM");

	vFlipScreen(1);
	
	sleep(500);
	waitForKeyPress();

	freeAllResources(resources, NUM_RESOURCES);
}
