#include <vmgp.h>	
#include <vstream.h>
#include "numberdrop.h"
#include "font.h"

const static uint8_t levels[25] = {70,68,66,24,20,28,56,54,52,50,48,46,44,42,40,38,36,34,32,30,28,26,24,22,20};

SPRITE *manAni[10][9]={	&m01,&m02,&m03,&m02,&m04,&m05,&m06,&m05,&m07,
						&m11,&m12,&m13,&m12,&m14,&m15,&m16,&m15,&m17,
						&m21,&m22,&m23,&m22,&m24,&m25,&m26,&m25,&m27,
						&m31,&m32,&m33,&m32,&m34,&m35,&m36,&m35,&m37,
						&m41,&m42,&m43,&m42,&m44,&m45,&m46,&m45,&m47,
						&m51,&m52,&m53,&m52,&m54,&m55,&m56,&m55,&m57,
						&m61,&m62,&m63,&m62,&m64,&m65,&m66,&m65,&m67,
						&m71,&m72,&m73,&m72,&m74,&m75,&m76,&m75,&m77,
						&m81,&m82,&m83,&m82,&m84,&m85,&m86,&m85,&m87,
						&m91,&m92,&m93,&m92,&m94,&m95,&m96,&m95,&m97};

SPRITE *numgfx[24]={&N0,&N1,&N2,&N3,&N4,&N5,&N6,&N7,&N8,&N9,&N10,&N11,&N0A,&N1A,&N2A,&N3A,&N4A,&N5A,&N6A,&N7A,&N8A,&N9A,&N10A,&N11A};

SCORE hi;
LEVEL curlvl;
NUMBER numbers[MAXNUMBERS];
MAN men[NUMMEN];
CLOUD clouds[3];

uint8_t pos;
int8_t str; // are we in a string?
uint8_t bonus; // are we in a bonus round?
uint8_t ncount; // counter for destroyed numbers
uint8_t numalive; // position for next number in array
uint8_t delaycnt; // counter for delay between numbers
uint8_t cloudspeed; // counter to slow clouds down
uint32_t score; // um...the score.
int8_t mencount; // number of men that are alive


//============
// High Score
//============
void displayHiScores(uint8_t u)
{
	uint8_t blah[8];
	vClearScreen(VMGP_BLACK);
	vDrawObject(0,0,&MENUBOX);

	printMain(26,6,"High Score",VMGP_BLACK);

	printMain(5,20,"1.",VMGP_BLACK);
	printMain(18,20,hi.name[0],VMGP_BLACK);
	vitoa(hi.score[0], blah, 8, ' ');
	printMain(48,20,blah,VMGP_BLACK);
	printMain(5,29,"2.",VMGP_BLACK);
	printMain(18,29,hi.name[1],VMGP_BLACK);
	vitoa(hi.score[1], blah, 8, ' ');
	printMain(48,29,blah,VMGP_BLACK);
	printMain(5,38,"3.",VMGP_BLACK);
	printMain(18,38,hi.name[2],VMGP_BLACK);
	vitoa(hi.score[2], blah, 8, ' ');
	printMain(48,38,blah,VMGP_BLACK);
	printMain(5,47,"4.",VMGP_BLACK);
	printMain(18,47,hi.name[3],VMGP_BLACK);
	vitoa(hi.score[3], blah, 8, ' ');
	printMain(48,47,blah,VMGP_BLACK);
	printMain(5,56,"5.",VMGP_BLACK);
	printMain(18,56,hi.name[4],VMGP_BLACK);
	vitoa(hi.score[4], blah, 8, ' ');
	printMain(48,56,blah,VMGP_BLACK);
	//if(u!=1) 
		printMain(5,65,"hit *",VMGP_BLACK);
	vFlipScreen(1);
	if(u==1){
		while(!vGetButtonData()){}
		while(vGetButtonData()){}
	}
	
}

void readHiScores()
{
	int res;
	res = vResOpenMode(NULL,HIGHSCORE,STREAM_READ);
	if(res > -1)
	{
		vResRead(res,&hi,sizeof(SCORE));
		vResClose(res);		
	}
	if(!hi.score[0]){
		vStrCpy(hi.name[0],ONE);
		vStrCpy(hi.name[1],TWO);
		vStrCpy(hi.name[2],THREE);
		vStrCpy(hi.name[3],FOUR);
		vStrCpy(hi.name[4],FIVE);
		hi.score[0]=1000;
		hi.score[1]=999;
		hi.score[2]=998;
		hi.score[3]=997;
		hi.score[4]=996;
		vClearScreen(vRGB(255,0,0));
		vFlipScreen(1);
	}	
}

void enterName(uint8_t *b)
{
	uint32_t keys;
	keys=vScanKeys();

	switch(keys)
	{
		case '2':
			if(b[pos]>='A'&&b[pos]<'C')
				b[pos]++;
			else
				b[pos]=65;
			break;
		case '3':
			if(b[pos]>='D'&&b[pos]<'F')
				b[pos]++;
			else
				b[pos]=68;
			break;
		case '4':
			if(b[pos]>='G'&&b[pos]<'I')
				b[pos]++;
			else
				b[pos]=71;
			break;
		case '5':
			if(b[pos]>='J'&&b[pos]<'L')
				b[pos]++;
			else
				b[pos]=74;
			break;
		case '6':
			if(b[pos]>='M'&&b[pos]<'O')
				b[pos]++;
			else
				b[pos]=77;
			break;
		case '7':
			if(b[pos]>='P'&&b[pos]<'S')
				b[pos]++;
			else
				b[pos]=80;
			break;
		case '8':
			if(b[pos]>='T'&&b[pos]<'V')
				b[pos]++;
			else
				b[pos]=84;
			break;
		case '9':
			if(b[pos]>='W'&&b[pos]<'Z')
				b[pos]++;
			else
				b[pos]=87;
			break;
		case '*': pos++; break;
	}
}

void checkNewScore()
{
	int8_t c=3,d=3;
	uint8_t *b;
	uint8_t blah[4];
	b=blah;
	if(score>hi.score[4]){//if score is higher than lowest hi-score
		while(score>hi.score[c]&&c>0)//sort it in
			c--;
		while(d>c-1){
			hi.score[d+1]=hi.score[d];
			vStrCpy(hi.name[d+1],hi.name[d]);
			d--;
		}
		hi.score[c]=score;
		vStrCpy(blah,SIX);
		//enter initials
		pos=0;
		while(pos<3){
			enterName(b);
			vStrCpy(hi.name[c],blah);
			displayHiScores(0);
		}
	}
}
void writeHiScores()
{
	int res;
	res = vResOpenMode(NULL,HIGHSCORE,STREAM_WRITE);
	if(res > -1)
	{
		vResWrite(res,&hi,sizeof(SCORE));
		vResClose(res);		
	}
}

void killone()
{
	//kill one man
	men[mencount].dead=DEAD;
	men[mencount].die=1;
	mencount--;
	vPlayResource(&bleep, bleep_SIZE,0);
}

//==============
//setup
//==============
void setupLevel(int8_t lvl)
{
	uint8_t c;
	uint8_t num[2];

	vSetRandom(vGetTickCount());

	//set level delay
	if(lvl<25)
		curlvl.delay = levels[lvl-1];
	else
		curlvl.delay = levels[24];

	//set total numbers for level
	if(lvl<4)
		curlvl.numbers = lvl*10;
	else
		curlvl.numbers = 5;
	
	//set level category to determine whats droped and color
	if(lvl<21)
	{
		curlvl.cat = (lvl-1)/5;
		switch(curlvl.cat)
		{
			case 0: curlvl.color=VMGP_BLUE; break;
			case 1: curlvl.color=vRGB(255,150,20); break;
			case 2: curlvl.color=vRGB(255,0,255); break;
			case 3: curlvl.color=vRGB(111,111,111); break;
		}

	}
	//after 20 nothing new comes up but we have to
	//mod the category result to get the right color
	else
	{
		curlvl.cat = 3;
		switch(((lvl-1)/5)%4)
		{
			case 0: curlvl.color=VMGP_BLUE; break;
			case 1: curlvl.color=vRGB(255,150,20); break;
			case 2: curlvl.color=vRGB(255,0,255); break;
			case 3: curlvl.color=vRGB(111,111,111); break;
		}
	}
	//initilize all numbers
	for(c=0;c<MAXNUMBERS;c++){
		numbers[c].dead=DEAD;
		numbers[c].x=0;
		numbers[c].y=-8;
		numbers[c].number[0]=0;
		numbers[c].pos=0;
		numbers[c].length=0;
	}

	delaycnt=100; // start delay counter high so we get a new number
	ncount=0; // start counter for destroyed numbers
	numalive=0; // start the array counter
	str=-1; // not in a string
}

void setupMen()
{
	uint8_t c;

	vSetRandom(vGetTickCount());

	//give the men random x locations and directions
	//random frames and make them all alive
	for(c=0;c<NUMMEN;c++)
	{
		men[c].x = vGetRandom()%93;
		men[c].y = 54;
		if(men[c].x%2 == 0){
			men[c].dir = LEFT;
			men[c].frame = 0;
		}
		else{
			men[c].dir = RIGHT;
			men[c].frame = 4;
		}
		men[c].die = 0;
		men[c].dead = ALIVE;
	}
}

void setupClouds()
{
	uint8_t c;
	
	//randomize by seconds
	TIMEDATE tm;
	vGetTimeDate(&tm);
	vSetRandom(tm.second);

	//they always go the same direction
	clouds[0].dir = LEFT;
	clouds[1].dir = RIGHT;
	clouds[2].dir = LEFT;

	//get random x locations
	for(c=0;c<3;c++)
	{
		clouds[c].x = vGetRandom()%87;
	}
}

//==============
//DRAW
//==============
void drawLevel()
{
	//draws bgcolor and bottom bar
	vClearScreen(curlvl.color);
	vDrawObject(0,70,&BOTTOM);
}

void drawMen()
{
	uint8_t c;
	//put all the men that are alive on the screen
	for(c=0;c<NUMMEN;c++)
	{
		if(men[c].dead==ALIVE)
			vDrawObject(men[c].x,men[c].y,manAni[c][men[c].frame]);
		//keep drawing them till they are off screen
		else
			if(men[c].die > 0)
				vDrawObject(men[c].x,men[c].y,manAni[c][men[c].frame]);
	}
}

void drawNumbers()
{
	uint8_t c,d;

	//draw all the alive numbers
	for(c=0;c<MAXNUMBERS;c++)
	{
		if(numbers[c].dead==ALIVE){ //only draw them if they are alive
			if(c==str){ // draw white ones if we are in a string
				for(d=0;d<numbers[c].length;d++)
					if(d<numbers[c].pos)
						vDrawObject(numbers[c].x+d*7,numbers[c].y,numgfx[numbers[c].number[d]+12]);
					else
						vDrawObject(numbers[c].x+d*7,numbers[c].y,numgfx[numbers[c].number[d]]);
			}
			else{
				for(d=0;d<numbers[c].length;d++)
					vDrawObject(numbers[c].x+d*7,numbers[c].y,numgfx[numbers[c].number[d]]);
			}
		}
	}
}

void drawClouds()
{
	//draw all the clouds
	vDrawObject(clouds[0].x,5,&CLOUD1);
	vDrawObject(clouds[1].x,20,&CLOUD2);
	vDrawObject(clouds[2].x,35,&CLOUD3);
}

//===============
// UPDATE
//===============
void updateNumbers()
{
	uint8_t c,d,e,n[3],l; // OMG, WTF? RTFM n00b

	//if count == delay reset count add a number
	if(delaycnt >= curlvl.delay)
	{
		switch(curlvl.cat)
		{
			//category 0: 1 num
			case 0: 
				n[0]=vGetRandom()%10;
				l=1;
				break;
			//category 1: add 2 num strings
			case 1:
				if(vGetRandom()%100 < 70)
				{
					n[0]=vGetRandom()%10;
					l=1;
				}
				else
				{
					for(c=0;c<2;c++)	n[c]=vGetRandom()%10;
					l=2;
				}
				break;
			//category 2: add # and *
			case 2:
				if(vGetRandom()%100 < 50)
				{
					n[0]=vGetRandom()%12;
					l=1;
				}
				else
				{
					for(c=0;c<2;c++)	n[c]=vGetRandom()%12;
					l=2;
				}
				break;
			//category 3: add 3 num strings
			case 3:
				e=vGetRandom()%100;
				if(e < 20)
				{
					n[0]=vGetRandom()%12;
					l=1;
				}
				else if(e>20&&e<60)
				{
					for(c=0;c<2;c++)	n[c]=vGetRandom()%12;
					l=2;
				}
				else
				{
					for(c=0;c<3;c++)	n[c]=vGetRandom()%12;
					l=3;
				}
				break;
		}
		d=numalive%9;
		vStrCpy(numbers[d].number,n);
		numbers[d].x = vGetRandom()%75;
		numbers[d].y = -8;
		numbers[d].length = l;
		numbers[d].pos = 0;
		numbers[d].dead = ALIVE;
		numalive++;
		delaycnt=0;
	}
	//move the numbers down 1 and if they are at
	//the bottom kill them and a man
	for(c=0;c<MAXNUMBERS;c++)
	{
		if(numbers[c].dead==ALIVE){
			if(numbers[c].y<62)
				numbers[c].y++;
			else{
				numbers[c].y=0;
				numbers[c].dead=DEAD;
				killone();
			}
		}
		else
			numbers[c].y=0;
	}
}

void updateMen()
{
	uint8_t c;
	for(c=0;c<NUMMEN;c++)
	{	
		if(men[c].dead==ALIVE) // move men back and forth
		{
			if(men[c].x>89){ men[c].dir=LEFT; men[c].frame=0; }
			if(men[c].x<1){ men[c].dir=RIGHT; men[c].frame=4; }
			if(men[c].dir==LEFT){ men[c].frame++;
				if(men[c].frame>3) men[c].frame=0;
			}
			else{ men[c].frame++;
				if(men[c].frame>7) men[c].frame=4;
			}
			if(men[c].dir==LEFT) men[c].x-=vGetRandom()%2+1;
			else men[c].x+=vGetRandom()%2+1;
		}
		else // die animation ... not a good way to do it but oh well
		{
			if(men[c].die==1||men[c].die==2)
			{
				men[c].y-=2;
				men[c].frame=8;
				men[c].die++;
			}
			else
			{
				if(men[c].die==3)
				{
					men[c].y+=3;
					if(men[c].y>80)
						men[c].die=0;
				}
			}
		}
	}
}

void updateClouds()
{
	// move the clounds across the screen and loop
	uint8_t c;
	if(cloudspeed%2==0)
	{
		for(c=0;c<3;c++)
		{
			if(clouds[c].x>101) clouds[c].x=-13;
			if(clouds[c].x<-13) clouds[c].x=101;
			if(clouds[c].dir==LEFT) clouds[c].x--;
			else clouds[c].x++;
		}
	}

	cloudspeed++;
	if(cloudspeed>100) cloudspeed=0;
}
//==========
// INPUT
//==========
void getInput() // read the input and update numbers acordingly
{	
	uint8_t c,d,q;
	int8_t p;
	uint32_t keys;
	keys=vScanKeys();

	switch(keys) // get 0-11 from the ascii values
	{
		case 42: c=10; break;
		case 35: c=11; break;
		default: c=keys-48; break;
	}

	p=-1; // array location for a match
	q=0; // height of match so we always get the lowest one

	if(str>-1) // first check the string if we are in one
		if(numbers[str].number[numbers[str].pos]==c&&numbers[str].dead==ALIVE)
			p=str;
	if(p<0) // otherwise check all the first numbers
		for(d=0;d<MAXNUMBERS;d++)
			if(numbers[d].dead==ALIVE && d!=str && numbers[d].number[0]==c)
				if(q<numbers[d].y){
					p=d;
					q=numbers[d].y;
				}
	if(p>-1){ // if we got a match update that number
		if(numbers[p].pos+1==numbers[p].length){
			numbers[p].dead=DEAD;
			vPlayResource(&technical, technical_SIZE,0);
			if(bonus>1)
				score+=200*numbers[p].length;
			else
				score+=100*numbers[p].length;
			ncount++;
			str=-1;
		}
		else{
			numbers[p].pos++;
			str=p;
		}	
	}
}

uint8_t level(int8_t lvl) // a level
{
	uint8_t ldone = 0; 
	setupLevel(lvl);
	while(1)
	{
		delaycnt++;

		getInput();

		updateNumbers();
		updateMen();
		updateClouds();

		drawLevel();	
		drawScoreLv(score, lvl);
		drawMen();
		drawClouds();
		drawNumbers();

		vFlipScreen(1);
		if(ncount==curlvl.numbers) ldone=1;
		if(men[0].y>80) return 1;
		if(ldone==1) return 0;
	}
}

uint8_t bonusround(int8_t lvl) // bonus round
{
	uint8_t bonusdone = 0;
	bonus=1;
	setupLevel(lvl+1);
	curlvl.delay=15;
	curlvl.numbers=40;
	curlvl.cat=3;
	while(1)
	{
		delaycnt++;

		getInput();

		updateNumbers();
		updateMen();
		updateClouds();

		drawLevel();	
		drawScoreLv(score, lvl);
		drawMen();
		drawClouds();
		drawNumbers();

		vFlipScreen(1);
		if(ncount==curlvl.numbers) bonusdone=1;
		if(men[0].y>80){
			setupMen();
			mencount=10;
			bonus=0;
			return 1;
		}
		if(bonusdone==1){
			setupMen();
			mencount=10;
			bonus=0;
			return 0;
		}
	}
}

void game(int8_t lvl)
{
	uint8_t alive = ALIVE;
	score=0;
	bonus=0;
	mencount=NUMMEN-1;
	uint8_t levelst[2];

	setupMen();
	setupClouds();

	while(level(lvl)==0)
	{
		if(lvl==25){
			vDrawObject(0,0,&ENDING);
			vFlipScreen(1);
			while(!vGetButtonData()){}
			while(vGetButtonData()){}
		}
		
		drawLevel();	
		drawScoreLv(score, lvl);
		drawMen();
		drawClouds();
		vitoa(lvl, levelst, 2, '0');
		vDrawObject(18,30,&TXTBOX);
		printMain(27,32,"Level",VMGP_BLUE);
		printMain(63,32,levelst,VMGP_BLUE);

		if(lvl%5==0){
			vDrawObject(18,30,&TXTBOX);
			printMain(20,32,"Panic",VMGP_BLUE);
			printMain(52,32,"Round",VMGP_BLUE);
			vFlipScreen(1);
			while(!vGetButtonData()){}
			while(vGetButtonData()){}
			bonusround(lvl);
		}

		lvl++;
		
		drawLevel();	
		drawScoreLv(score, lvl);
		drawMen();
		drawClouds();
		vitoa(lvl, levelst, 2, '0');
		vDrawObject(18,30,&TXTBOX);
		printMain(27,32,"Level",VMGP_BLUE);
		printMain(63,32,levelst,VMGP_BLUE);
		vFlipScreen(1);
		while(!vGetButtonData()){}
		while(vGetButtonData()){}
	}
	vDrawObject(18,30,&TXTBOX);		// game over
	printMain(24,32,"GAME OVER",VMGP_RED);
	vFlipScreen(1);
	while(!vGetButtonData()){}
	while(vGetButtonData()){}
	//high score check/enter/save
	checkNewScore();
	writeHiScores();
}
