#include <vmgp.h>	
#include <vstream.h>
#include <vsound.h>
#include "numberdrop.h"
#include "font.h"
						//  01 02 03 04 05 06 07 08 09 10 11 12 13 14 15 16 17 18 19 20 21 22 23 24 25
const uint8_t levels[25] = {90,85,80,90,85,83,80,85,83,83,80,80,85,85,83,83,81,81,80,80,78,78,76,76,74};

SPRITE *manAni[10][9]={	&m01,&m02,&m03,&m02,&m04,&m05,&m06,&m05,&m07,
						&m11,&m12,&m13,&m12,&m14,&m15,&m16,&m15,&m17,
						&m21,&m22,&m23,&m22,&m24,&m25,&m26,&m25,&m27,
						&m31,&m32,&m33,&m32,&m34,&m35,&m36,&m35,&m37,
						&m41,&m42,&m43,&m42,&m44,&m45,&m46,&m45,&m47,
						&m51,&m52,&m53,&m52,&m54,&m55,&m56,&m55,&m57,
						&m61,&m62,&m63,&m62,&m64,&m65,&m66,&m65,&m67,
						&m71,&m72,&m73,&m72,&m74,&m75,&m76,&m75,&m77,
						&m81,&m82,&m83,&m82,&m84,&m85,&m86,&m85,&m87,
						&m91,&m92,&m93,&m92,&m94,&m95,&m96,&m95,&m97};

SPRITE *numgfx[24]={&N0,&N1,&N2,&N3,&N4,&N5,&N6,&N7,&N8,&N9,&N10,&N11,&N0A,&N1A,&N2A,&N3A,&N4A,&N5A,&N6A,&N7A,&N8A,&N9A,&N10A,&N11A};

SCORE hi;
LEVEL curlvl;
NUMBER numbers[MAXNUMBERS];
MAN men[NUMMEN];
CLOUD clouds[3];

uint8_t sound; // sound on/off
uint8_t bonus; // are we in a bonus round?
int8_t str; // are we in a string?
uint8_t ncount; // counter for destroyed numbers
uint8_t numalive; // position for next number in array
uint16_t delaycnt; // counter for delay between numbers
uint8_t cloudspeed; // counter to slow clouds down
uint32_t score; // um...the score.
int8_t mencount; // number of men that are alive
int8_t input;
HSOUND beep1, beep2;

//=============
// Compression
//=============
int32_t LoadPackedRes(uint16_t res_id,uint16_t dst_size,uint8_t**ptrDest)
{	
	int32_t		handle,size;
 	
	handle    = vResOpen(NULL,res_id);
	*ptrDest  = vNewPtr(dst_size);
	size      = vDecompress(NULL, *ptrDest, handle, 1024);
	vStreamClose(handle);
	return size;
}

//=============
// Stuff
//=============
void waitForButton()
{
	while(!vScanKeys()){}
	while(vScanKeys()){}
}

void playSound(uint8_t s)
{  
	switch(s)
	{
	case 1:
		if(sound==ON){
			vSoundPlay(beep1, 0);
		}
		break;
	case 2:
		if(sound==ON){
			vSoundPlay(beep2, 0);
		}
		break;
	}
}

void delay(uint32_t x)
{
	uint32_t c;
	for(c=0;c<x;c++)
		vFlipScreen(1);
}

void killone()
{
	//kill one man
	men[mencount].dead=DEAD;
	men[mencount].die=1;
	mencount--;
	playSound(1);
}

//============
// High Score
//============
void displayHiScores(uint8_t u, uint8_t *m1, uint8_t *m2, uint8_t *m3, uint8_t *m4)
{
	uint8_t blah[8];
	vClearScreen(VMGP_BLACK);
	vDrawObject(0,0,m1);
	vDrawObject(0,60,m2);
	vDrawObject(SCREEN_WIDTH-27,60,m3);
	vDrawObject(0,169,m4);
	uint8_t sx=40,sy=65,xinc=14,yinc=12,x2=50;

	printMain(sx+18,sy,"HIGH SCORES",VMGP_WHITE);

	printMain(sx,sy+yinc,"1.",VMGP_RED);
	printMain(sx+xinc,sy+yinc,hi.name[0],VMGP_WHITE);
	vitoa(hi.score[0], blah, 8, ' ');
	printMain(sx+x2,sy+yinc,blah,VMGP_WHITE);

	printMain(sx,sy+yinc*2,"2.",VMGP_RED);
	printMain(sx+xinc,sy+yinc*2,hi.name[1],VMGP_WHITE);
	vitoa(hi.score[1], blah, 8, ' ');
	printMain(sx+x2,sy+yinc*2,blah,VMGP_WHITE);

	printMain(sx,sy+yinc*3,"3.",VMGP_RED);
	printMain(sx+xinc,sy+yinc*3,hi.name[2],VMGP_WHITE);
	vitoa(hi.score[2], blah, 8, ' ');
	printMain(sx+x2,sy+yinc*3,blah,VMGP_WHITE);

	printMain(sx,sy+yinc*4,"4.",VMGP_RED);
	printMain(sx+xinc,sy+yinc*4,hi.name[3],VMGP_WHITE);
	vitoa(hi.score[3], blah, 8, ' ');
	printMain(sx+x2,sy+yinc*4,blah,VMGP_WHITE);

	printMain(sx,sy+yinc*5,"5.",VMGP_RED);
	printMain(sx+xinc,sy+yinc*5,hi.name[4],VMGP_WHITE);
	vitoa(hi.score[4], blah, 8, ' ');
	printMain(sx+x2,sy+yinc*5,blah,VMGP_WHITE);

	if(u==1){
		vFlipScreen(1);
		waitForButton();
	}
}

void worthless()
{
	printMain(45,145,"HIT * FOR NEXT",VMGP_WHITE);
	vFlipScreen(1);
}

void writeHiScores()
{
	int res;
	res = vResOpenMode(NULL,HIGHSCORE,STREAM_WRITE);
	if(res > -1)
	{
		vResWrite(res,&hi,sizeof(SCORE));
		vResClose(res);		
	}
}

void readHiScores()
{
	int res;
	res = vResOpenMode(NULL,HIGHSCORE,STREAM_READ);
	if(res > -1)
	{
		vResRead(res,&hi,sizeof(SCORE));
		vResClose(res);		
	}
	if(!hi.score[0]){
		vStrCpy(hi.name[0],ONE);
		vStrCpy(hi.name[1],TWO);
		vStrCpy(hi.name[2],THREE);
		vStrCpy(hi.name[3],FOUR);
		vStrCpy(hi.name[4],FIVE);
		hi.score[0]=50000;
		hi.score[1]=40000;
		hi.score[2]=30000;
		hi.score[3]=20000;
		hi.score[4]=10000;
		writeHiScores();
	}	
}

void enterName(uint8_t *b, uint8_t *pos)
{
	uint32_t keys;

	keys=vScanKeys();

	switch(keys)
	{
		case '2':
			if(b[*pos]>='A'&&b[*pos]<'C')
				b[*pos]++;
			else
				b[*pos]=65;
			break;
		case '3':
			if(b[*pos]>='D'&&b[*pos]<'F')
				b[*pos]++;
			else
				b[*pos]=68;
			break;
		case '4':
			if(b[*pos]>='G'&&b[*pos]<'I')
				b[*pos]++;
			else
				b[*pos]=71;
			break;
		case '5':
			if(b[*pos]>='J'&&b[*pos]<'L')
				b[*pos]++;
			else
				b[*pos]=74;
			break;
		case '6':
			if(b[*pos]>='M'&&b[*pos]<'O')
				b[*pos]++;
			else
				b[*pos]=77;
			break;
		case '7':
			if(b[*pos]>='P'&&b[*pos]<'S')
				b[*pos]++;
			else
				b[*pos]=80;
			break;
		case '8':
			if(b[*pos]>='T'&&b[*pos]<'V')
				b[*pos]++;
			else
				b[*pos]=84;
			break;
		case '9':
			if(b[*pos]>='W'&&b[*pos]<'Z')
				b[*pos]++;
			else
				b[*pos]=87;
			break;
		case '*':
			(*pos)++;
			if(*pos<3) b[*pos]=95;
			break;
	}

	while(vScanKeys()){}
}

void checkNewScore()
{
	int8_t c=3,d=3;
	uint8_t *b,*m1,*m2,*m3,*m4;
	uint8_t blah[4],pos;
	b=blah;
	if(score>hi.score[4]){//if score is higher than lowest hi-score
		while(score>hi.score[c]&&c>=0)//sort it in
			c--;
		while(d>c-1){
			hi.score[d+1]=hi.score[d];
			vStrCpy(hi.name[d+1],hi.name[d]);
			d--;
		}
		c++;
		hi.score[c]=score;
		vStrCpy(blah,SIX);
		//enter initials
		pos=0;
		LoadPackedRes(MENU1,MENU1_UNPACKED_SIZE ,&m1);
		LoadPackedRes(MENU2,MENU2_UNPACKED_SIZE ,&m2);
		LoadPackedRes(MENU3,MENU3_UNPACKED_SIZE ,&m3);
		LoadPackedRes(MENU4,MENU4_UNPACKED_SIZE ,&m4);

		while(pos<3){
			enterName(b,&pos);
			vStrCpy(hi.name[c],blah);
			displayHiScores(0,m1,m2,m3,m4);
			worthless();
		}
		vDisposePtr(m1);
		vDisposePtr(m2);
		vDisposePtr(m3);
		vDisposePtr(m4);
	}
}

//==============
//setup
//==============
void setupLevel()
{
	uint8_t c;
	vSetRandom(vGetTickCount());

	//set level delay
	if(curlvl.level<25)
		curlvl.delay = levels[curlvl.level-1];
	else
		curlvl.delay = levels[24];

	//set total numbers for level
	if(curlvl.level<4){
		curlvl.numbers = 15;
		curlvl.cat = 0;
	}
	else if(curlvl.level<8){
		curlvl.numbers = 20;
		curlvl.cat = 1;
	}
	else if(curlvl.level<13){
		curlvl.numbers = 25;
		curlvl.cat = 2;
	}
	else{
		curlvl.numbers = 30;
		curlvl.cat = 3;
	}

	//set level category to determine whats droped and color
	if(curlvl.level<21){
		switch((curlvl.level-1)/5){
			case 0: curlvl.color=vRGB(0,109,255); break;
			case 1: curlvl.color=vRGB(255,150,20); break;
			case 2: curlvl.color=vRGB(255,0,255); break;
			case 3: curlvl.color=vRGB(111,111,111); break;
		}
	}
	//after 20 nothing new comes up but we have to
	//mod the category result to get the right color
	else{
		switch(((curlvl.level-1)/5)%4){
			case 0: curlvl.color=vRGB(0,109,255); break;
			case 1: curlvl.color=vRGB(255,150,20); break;
			case 2: curlvl.color=vRGB(255,0,255); break;
			case 3: curlvl.color=vRGB(111,111,111); break;
		}
	}
	if(bonus==1)
	{
		curlvl.numbers = 30;
		curlvl.cat = 4;
		curlvl.delay = 67;
		curlvl.color = vRGB(0,0,0);
	}
	//initilize all numbers
	for(c=0;c<MAXNUMBERS;c++){
		numbers[c].dead=DEAD;
		numbers[c].x=0;
		numbers[c].y=-NUM_HEIGHT;
		numbers[c].number[0]=0;
		numbers[c].pos=0;
		numbers[c].length=0;
	}
	delaycnt=150; // start delay counter high so we get a new number
	ncount=0; // start counter for destroyed numbers
	numalive=0; // start the array counter
	str=-1; // not in a string
}

void setupMen()
{
	uint8_t c;
	vSetRandom(vGetTickCount());

	//give the men random x locations and directions
	//random frames and make them all alive
	for(c=0;c<NUMMEN;c++){
		men[c].x = vGetRandom()%(SCREEN_WIDTH-12);
		men[c].y = SCREEN_HEIGHT-BOTTOM_H-16;
		if(men[c].x%2 == 0){
			men[c].dir = LEFT;
			men[c].frame = 0;
		}
		else{
			men[c].dir = RIGHT;
			men[c].frame = 4;
		}
		men[c].die = 0;
		men[c].dead = ALIVE;
	}
}

void setupClouds()
{
	uint8_t c;
	vSetRandom(vGetTickCount());

	//they always go the same direction
	clouds[0].dir = LEFT;
	clouds[1].dir = RIGHT;
	clouds[2].dir = LEFT;

	//get random x locations
	for(c=0;c<3;c++){
		clouds[c].x = vGetRandom()%(SCREEN_WIDTH-25);
	}
}

//==============
//DRAW
//==============
void drawMen()
{
	uint8_t c;
	//put all the men that are alive on the screen
	for(c=0;c<NUMMEN;c++)
	{
		if(men[c].dead==ALIVE)
			vDrawObject(men[c].x,men[c].y,manAni[c][men[c].frame]);
		//keep drawing them till they are off screen
		else
			if(men[c].die > 0)
				vDrawObject(men[c].x,men[c].y,manAni[c][men[c].frame]);
	}
}

void drawNumbers()
{
	uint8_t c,d;

	//draw all the alive numbers
	for(c=0;c<MAXNUMBERS;c++)
	{
		if(numbers[c].dead==ALIVE){ 
			// draw white ones if we are in a string
			if(c==str){ 
				for(d=0;d<numbers[c].length;d++)
					if(d<numbers[c].pos)
						vDrawObject(numbers[c].x+d*13,numbers[c].y,numgfx[numbers[c].number[d]+12]);
					else
						vDrawObject(numbers[c].x+d*13,numbers[c].y,numgfx[numbers[c].number[d]]);
			}
			else{
				for(d=0;d<numbers[c].length;d++)
					vDrawObject(numbers[c].x+d*13,numbers[c].y,numgfx[numbers[c].number[d]]);
}	}	}	}

void drawClouds()
{
	vDrawObject(clouds[0].x,5,&CLOUD1);
	vDrawObject(clouds[1].x,20,&CLOUD2);
	vDrawObject(clouds[2].x,35,&CLOUD3);
}

void drawLevel()
{
	vClearScreen(curlvl.color);
	vDrawObject(0,SCREEN_HEIGHT-BOTTOM_H,&BOTTOM);
}
//===============
// UPDATE
//===============
void updateNumbers()
{
	uint8_t c,d,e,n[3],l; // OMG, WTF? RTFM n00b

	//if count == delay reset count add a number
	if(delaycnt >= curlvl.delay)
	{
		switch(curlvl.cat){
			case 0: //1 digit
				n[0]=vGetRandom()%10;
				l=1;
				break;
			case 1: //add 2 digits
				if(vGetRandom()%100 < 70){
					n[0]=vGetRandom()%10;
					l=1;
				}
				else{
					for(c=0;c<2;c++)	n[c]=vGetRandom()%10;
					l=2;
				}
				break;
			case 2: //add * and #
				if(vGetRandom()%100 < 50)
				{
					n[0]=vGetRandom()%12;
					l=1;
				}
				else
				{
					for(c=0;c<2;c++)	n[c]=vGetRandom()%12;
					l=2;
				}
				break;
			default: //add 3 num strings
				e=vGetRandom()%100;
				if(e < 20)
				{
					n[0]=vGetRandom()%12;
					l=1;
				}
				else if(e>20&&e<60)
				{
					for(c=0;c<2;c++)	n[c]=vGetRandom()%12;
					l=2;
				}
				else
				{
					for(c=0;c<3;c++)	n[c]=vGetRandom()%12;
					l=3;
				}
				break;
		}
		d=numalive%MAXNUMBERS;
		vStrCpy(numbers[d].number,n);
		numbers[d].x = vGetRandom()%(SCREEN_WIDTH-3*(NUM_WIDTH+1));
		numbers[d].y = -NUM_HEIGHT;
		numbers[d].length = l;
		numbers[d].pos = 0;
		numbers[d].dead = ALIVE;
		numalive++;
		delaycnt=0;  
	}
	//move the numbers down 1 and if they are at
	//the bottom kill them and a man
	int blah = SCREEN_HEIGHT-NUM_HEIGHT-BOTTOM_H;
	for(c=0;c<MAXNUMBERS;c++)
	{
		if(numbers[c].dead==ALIVE&&cloudspeed%2==0){
			if(numbers[c].y<blah)
				if(bonus==1)
					numbers[c].y++;
				else
					if(curlvl.level<6)
						numbers[c].y++;
					else if(curlvl.level<11)
						numbers[c].y++;
					else if(curlvl.level<13)
						numbers[c].y++;
					else
						numbers[c].y++;
			else{
				numbers[c].y=0;
				numbers[c].dead=DEAD;
				killone();
}	}	}	}

void updateMen()
{
	uint8_t c;
	if(cloudspeed%2==0)
	{
	for(c=0;c<NUMMEN;c++)
	{	
		if(men[c].dead==ALIVE) // move men back and forth
		{
			if(men[c].x>SCREEN_WIDTH-MEN_WIDTH){ men[c].dir=LEFT; men[c].frame=0; }
			if(men[c].x<1){ men[c].dir=RIGHT; men[c].frame=4; }
			if(men[c].dir==LEFT){ men[c].frame++;
				if(men[c].frame>3) men[c].frame=0;
			}
			else{ men[c].frame++;
				if(men[c].frame>7) men[c].frame=4;
			}
			if(men[c].dir==LEFT) men[c].x-=vGetRandom()%2+1;
			else men[c].x+=vGetRandom()%2+1;
		}
		else // die animation ... not a good way to do it but oh well
		{
			if(men[c].die<4&&men[c].die>0)
			{
				men[c].y-=6;
				men[c].frame=8;
				men[c].die++;
			}
			else
			{
				if(men[c].die==4)
				{
					men[c].y+=2;
					if(men[c].y>SCREEN_HEIGHT)
						men[c].die=0;
				}
			}
		}
	}}
}

void updateClouds()
{
	// move the clounds across the screen and loop
	uint8_t c;
	if(cloudspeed%2==0)
	{
		for(c=0;c<3;c++)
		{
			if(clouds[c].x>SCREEN_WIDTH) clouds[c].x=-13;
			if(clouds[c].x<-13) clouds[c].x=SCREEN_WIDTH;
			if(clouds[c].dir==LEFT) clouds[c].x--;
			else clouds[c].x++;
		}
	}

	cloudspeed++;
	if(cloudspeed>100) cloudspeed=0;
}
//==========
// INPUT
//==========
void getInput() // read the input and update numbers acordingly
{	
	uint8_t c,d;
	uint16_t q;
	int8_t p;
	uint32_t keys;

	if(input==0)
	{

	keys=vScanKeys();

	switch(keys) // get 0-11 from the ascii values
	{
		case 42: c=10; break;
		case 35: c=11; break;
		default: c=keys-48; break;
	}

	p=-1; // array location for a match
	q=0; // height of match so we always get the lowest one

	if(str>-1) // first check the string if we are in one
		if(numbers[str].number[numbers[str].pos]==c&&numbers[str].dead==ALIVE)
			p=str;
	if(p<0) // otherwise check all the first numbers
		for(d=0;d<MAXNUMBERS;d++)
			if(numbers[d].dead==ALIVE && d!=str && numbers[d].number[0]==c)
				if(q<numbers[d].y){
					p=d;
					q=numbers[d].y;
					numbers[str].pos = 0;
					str = -1;
				}
	if(p>-1){ // if we got a match update that number
		if(numbers[p].pos+1==numbers[p].length){
			numbers[p].dead=DEAD;
			playSound(2);
			if(bonus==1)
				score+=250*numbers[p].length;
			else
				score+=100*numbers[p].length;
			ncount++;
			str=-1;
		}
		else{
			numbers[p].pos++;
			str=p;
		}
		input=1;
	}
	}
	else
		if(vScanKeys()==0) input=0;
}

uint8_t level()
{
	uint8_t ldone = 0; 
	uint8_t levelst[2];
	setupLevel();

	vSoundInit();
	beep1 = vSoundGetHandle((int32_t*)BEEP1);
	beep2 = vSoundGetHandle((int32_t*)BEEP2);

	drawLevel();
	drawScoreLv(score,curlvl.level);
	drawMen();
	drawClouds();
	drawNumbers();
	vFlipScreen(1);
	
	if(bonus==1)
	{
		vDrawObject(SCREEN_WIDTH/2-32,SCREEN_HEIGHT/2-5,&TXTBOX);
		printMain(SCREEN_WIDTH/2-29,SCREEN_HEIGHT/2-3,"PANIC",VMGP_BLUE);
		printMain(SCREEN_WIDTH/2+2,SCREEN_HEIGHT/2-3,"ROUND",VMGP_BLUE);
	}
	else
	{
		vitoa(curlvl.level, levelst, 2, '0');
		vDrawObject(SCREEN_WIDTH/2-32,SCREEN_HEIGHT/2-5,&TXTBOX);
		printMain(SCREEN_WIDTH/2-22,SCREEN_HEIGHT/2-3,"LEVEL",VMGP_BLUE);
		printMain(SCREEN_WIDTH/2+12,SCREEN_HEIGHT/2-3,levelst,VMGP_BLUE);
	}
	vFlipScreen(1);
	while(vScanKeys()){}
	waitForButton();

	while(1)
	{
		delaycnt++;

		getInput();

		if(score>=99999900)
			score=99999900;

		updateNumbers();
		updateMen();
		updateClouds();

		drawLevel();
		drawScoreLv(score,curlvl.level);
		drawMen();
		drawClouds();
		drawNumbers();
		vFlipScreen(1);

		if(ncount==curlvl.numbers) ldone=1;
		if(men[0].y>SCREEN_HEIGHT)
		{
			if(bonus==1){
				setupMen();
				mencount=10;
			}
			vSoundDisposeHandle(beep1);
			vSoundDisposeHandle(beep2);
  			vSoundDispose();
			return 1;
		}
		if(ldone==1){
			if(bonus==1){
				setupMen();
				mencount = 10;
				score += 50000;
			}

			vSoundDisposeHandle(beep1);
			vSoundDisposeHandle(beep2);
			vSoundDispose();
			return 0;
		}
	}
}

void game(int8_t lvl, uint8_t s, uint8_t dmode)
{
	uint8_t alive = ALIVE;
	if(s==ON)
		sound=ON;
	else
		sound=OFF;
	score=0;
	curlvl.level=lvl;
	input=1;
	bonus=0;
	mencount=NUMMEN-1;

	setupMen();
	setupClouds();

	while(level()==0)
	{
		if(lvl==25){
			uint8_t *e1,*e2;
			LoadPackedRes(END1,END1_UNPACKED_SIZE ,&e1);
			LoadPackedRes(END2,END2_UNPACKED_SIZE ,&e2);
			vDrawObject(0,0,e1);
			vDrawObject(0,104,e2);
			vFlipScreen(1);
			waitForButton();
			vDisposePtr(e1);
			vDisposePtr(e2);
		}
		if(curlvl.level%5==0 && curlvl.level<25){
			bonus=1;
			level();
			bonus=0;
		}

		curlvl.level++;
		
		if(dmode==YES && lvl>5)
			break;
		if(curlvl.level>99)
			curlvl.level=99;
	}
	vDrawObject(SCREEN_WIDTH/2-32,SCREEN_HEIGHT/2-5,&TXTBOX);
	printMain(SCREEN_WIDTH/2-27,SCREEN_HEIGHT/2-3,"GAME OVER",VMGP_RED);
	vFlipScreen(1);
	waitForButton();
	if(dmode==YES)
		vMsgBox(VMB_TITLE,"Thank you for playing the demo of Number Drop. Please purchase the game to unlock more levels!","Numberdrop");
	//high score check/enter/save
	checkNewScore();
	writeHiScores();
}
