#include <vmgp.h>
#include "res.h"

#include "globals.h"
#include "unit.h"
#include "inventoryitem.h"

uint32_t	seeds[NUM_LEVELS];	
uint8_t		treasurecollection[NUM_TREASURES];
UNIT		sprites[MAX_SPRITES];
uint16_t	width, height;		//Dimensions of the screen
uint8_t		canVibrate;			//0 if disabled, 1 if enabled
uint8_t		doesVibrate = 1, 
			sound = 1;			//0 if disabled, 1 if enabled
int16_t		mapX, mapY;
uint8_t		*map;
uint8_t		level;
uint8_t		floor1, floor2;
uint8_t		log;

INVENTORYITEM inventory[MAX_INVENTORY];

uint16_t musicres[] = {	MDUNGEON1, MDUNGEON1_UNPACKED_SIZE,
						MDUNGEON2, MDUNGEON2_UNPACKED_SIZE,
						MDUNGEON3, MDUNGEON3_UNPACKED_SIZE,
						MDUNGEON4, MDUNGEON4_UNPACKED_SIZE,
						MDUNGEON5, MDUNGEON5_UNPACKED_SIZE };
uint8_t* music = NULL;
uint8_t playerIsDead;
uint8_t debug = 0;
uint8_t vanish;
uint8_t demo = 0;
uint32_t demoTime;

//Treasure names & information
char* legendaryTreasures[] = 
{
	"MOON ROCK",		"A SMALL CHUNK OF THE MOON",
	"HOLY GRAIL",		"A CUP SAID TO BE USED BY JESUS AT THE LAST SUPPER",
	"FORTUNE SONG",		"A SONG SAID TO BRING GOOD LUCK TO ALL WHO HEAR IT",
	"MIDAS GAUNTLET",	"THESE CHANGE ALL THEY TOUCH TO GOLD",
	"THIEF RING",		"CLOAKS ITS WEARER IN DARKNESS",
	"SUN TZUS TOME",	"CONTAINS WAR TACTICS SAID TO BE FLAWLESS",
	"ANGEL QUILL",		"INSPIRES BEAUTIFUL POETRY WRITING",
	"ETERNAL CANDLE",	"A CANDLE THAT CAN NEVER BE PUT OUT",
	"PEACEMAKER",		"A GUN THAT NEVER LOST A SHOWDOWN",
	"WAR BELL",			"GREATLY IMPROVES MORALE WHEN RANG",
	"MASAMUNE",			"LEGENDARY SWORD THAT CAN CUT ANYTHING",
	"ROYAL ROBE",		"GIVES THE POWER TO RULE A NATION",
	"SNORKEL",			"ALLOWS HUMANS TO BREATHE UNDER WATER",
	"MIRROR SHIELD",	"SAID TO REFLECT ANYTHING CAST ONTO IT",
	"UNICORN HORN",		"WHEN GROUND INTO POWDER, HEALS ANY AILMENT",
	"X-RAY GLASSES",	"ALLOWS ITS WEARER TO SEE THROUGH OBJECTS",
	"PANODRAS BOX",		"LEGENDARY BOX SAID TO CONTAIN MISFORTUNE",
	"EXCALIBUR",		"MOST POWERFUL SWORD IN EXISTENCE",
	"SANDS OF TIME",	"HAS THE ABILITY TO CONTROL TIME",
	"HALO",				"LETS HUMANS FLY TO THE HEAVENS"
};

//Monster descriptions
UNIT unitstats[] = {
	{
		DARYL,
		PLAYER,
		"DARYL",
		1, 1,
		0, 0,
		100,
		0,
		0,
		0, 0, 0,
		0, 0, 0, 0, 0, -1, -1, -1
	},
	{
		PELLET,
		ENEMY,
		"PELLET",
		1, 1,
		0, 0,
		10,
		3,
		1,
		0, 0, 0,
		0, 0, 0, 0, 0, 0, 0, 0
	},
	{
		GARGOYLE,
		ENEMY,
		"GARGOYLE",
		1, 1,
		0, 0, 
		20,
		5,
		2,
		0, 0, 0,
		0, 0, 0, 0, 0, 0, 0, 0
	},
	{
		HERMIE,
		ENEMY,
		"HERMIE",
		1, 1,
		0, 0, 
		12, 
		4,
		2,
		0, 0, 0,
		0, 0, 0, 0, 0, 0, 0, 0
	},
	{
		PICKLEMAN,
		ENEMY,
		"PICKLEMAN",
		1, 1,
		0, 0, 
		16,
		6,
		1,
		0, 0, 0,
		0, 0, 0, 0, 0, 0, 0, 0
	},
	{
		DRAGON,
		ENEMY,
		"DRAGON",
		1, 1,
		0, 0, 
		25,
		15,
		3,
		0, 0, 0,
		0, 0, 0, 0, 0, 0, 0, 0
	},
	{
		SKELETON,
		ENEMY,
		"SKELETON",
		1, 1,
		0, 0, 
		20,
		5,
		2,
		0, 0, 0,
		0, 0, 0, 0, 0, 0, 0, 0
	},
	{
		GHOST,
		ENEMY,
		"GHOST",
		1, 1,
		0, 0, 
		16,
		7,
		1,
		0, 0, 0,
		0, 0, 0, 0, 0, 0, 0, 0
	},
	{
		FANGOLA,
		ENEMY,
		"FANGOLA",
		1, 1,
		0, 0, 
		17,
		5,
		2,
		0, 0, 0,
		0, 0, 0, 0, 0, 0, 0, 0
	},
	{
		MIMIC,
		ENEMY,
		"MIMIC",
		1, 1,
		0, 0, 
		20,
		10,
		2,
		0, 0, 0,
		0, 0, 0, 0, 0, 0, 0, 0
	},
	{
		CHEST,
		TREASURE,
		"CHEST",
		1, 1,
		0, 0,
		0, 0, 0,
		0, 0, 0,
		0, 0, 0, 0, 0, 0, 0, 0
	},
	{
		STAIRSUP,
		STAIRS_UP,
		"STAIRSUP",
		1, 1,
		0, 0, 0, 0, 0,
		0, 0, 0,
		0, 0, 0, 0, 0, 0, 0, 0
	},
	{
		STAIRSDOWN,
		STAIRS_DOWN,
		"STAIRSDOWN",
		1, 1,
		0, 0, 0, 0, 0,
		0, 0, 0,
		0, 0, 0, 0, 0, 0, 0, 0
	}

};

//Items that can show up in the inventory
INVENTORYITEM items[] = {
	//Armor
	{
		"LEATHER ARMOR",
		LARMOR,
		ARMOR,
		8,
		0, 0
	},
	{
		"SILVER ARMOR",
		SARMOR,
		ARMOR,
		4,
		0, 0
	},
	{
		"HOLY ARMOR",
		HARMOR,
		ARMOR,
		4,
		0, 0
	},
	{
		"DEMON ARMOR",
		DARMOR,
		ARMOR,
		2,
		0, 0
	},
	{
		"GRAND ARMOR",
		GARMOR,
		ARMOR,
		2,
		0, 0
	},

	//Weapons
	{
		"DIRK",
		DIRK,
		WEAPON,
		6,
		25, 0
	},
	{
		"COPPER SWORD",
		CSWORD,
		WEAPON,
		8,
		40, 0
	},
	{
		"MIDAS BLADE",
		MBLADE,
		WEAPON,
		10,
		50, 0
	},
	{
		"SPIRIT SWORD",
		SSWORD,
		WEAPON,
		12,
		65, 0
	},
	{
		"CHAOS BLADE",
		CHBLADE,
		WEAPON,
		14,
		80, 0
	},

	//Accessories
	{
		"HOLY CROSS",
		HCROSS,
		ACCESSORY,
		0, 0, 0
	},
	{
		"MANDRAKE ROOT",
		MANDRAKE,
		ACCESSORY,
		0, 0, 0
	},
	{
		"HERMES BOOTS",
		HBOOT,
		ACCESSORY,
		0, 75, 0
	},
	{
		"DRAGONS SKULL",
		DSKULL,
		ACCESSORY,
		0, 0, 0
	},
	{
		"IRON MASK",
		IRONMASK,
		ACCESSORY,
		0, 0, 0
	},

	//Scrolls
	{
		"SCROLL OF SORROW",
		SCROLL,
		ITEM,
		10,
		0, 0
	},
	{
		"SCROLL OF EXPLOSION",
		SCROLL,
		ITEM,
		15,
		0, 0
	},
	{
		"SCROLL OF TELEPORT",
		SCROLL,
		ITEM,
		0, 0, 0
	},
	{
		"SCROLL OF WISDOM",
		SCROLL,
		ITEM,
		0, 0, 0
	},
	{
		"SCROLL OF POWER",
		SCROLL,
		ITEM,
		2,
		0, 0
	},
	{
		"SCROLL OF MYSTERY",
		SCROLL,
		ITEM,
		0, 0, 0
	},

	//Consumable items
	{
		"GREEN POTION",
		GPOTION,
		ITEM,
		50,
		0, 0
	},
	{
		"BLUE POTION",
		BPOTION,
		ITEM,
		0,
		0, 0
	},
	{
		"PURPLE POTION",
		PPOTION,
		ITEM,
		25,
		0, 0
	},
	{
		"RED POTION",
		RPOTION,
		ITEM,
		100,
		0, 0
	},
	{
		"YELLOW POTION",
		YPOTION,
		ITEM,
		0, 0, 0
	},
	{
		"ORANGE POTION",
		OPOTION,
		ITEM,
		0, 0, 0
	},
	{
		"WHITE POTION",
		WPOTION,
		ITEM,
		25,
		0, 0
	},
	{
		"BLACK POTION",
		BLPOTION,
		ITEM,
		0, 0, 0
	},
	//Legendary treasures
	{
		"MOON ROCK",
		MOONROCK,
		LTREASURE,
		0, 0, 0
	},
	{
		"HOLY GRAIL",
		HOLYGRAIL,
		LTREASURE,
		0, 0, 0
	},
	{
		"FORTUNE SONG",
		FORTUNESONG,
		LTREASURE,
		0, 0, 0
	},
	{
		"MIDAS GAUNTLET",
		MIDASGAUNTLET,
		LTREASURE,
		0, 0, 0
	},
	{
		"THIEF RING",
		THIEFRING,
		LTREASURE,
		0, 0, 0
	},
	{
		"SUN TZUS TOME",
		SUNTZUBOOK,
		LTREASURE,
		0, 0, 0
	},
	{
		"ANGEL QUILL",
		ANGELQUILL,
		LTREASURE,
		0, 0, 0
	},
	{
		"ETERNAL CANDLE",
		ETERNALCANDLE,
		LTREASURE,
		0, 0, 0
	},
	{
		"PEACEMAKER",
		PEACEMAKER,
		LTREASURE,
		0, 0, 0
	},
	{
		"WAR BELL",
		WARBELL,
		LTREASURE,
		0, 0, 0
	},
	{
		"MASAMUNE",
		MASAMUNE,
		LTREASURE,
		0, 0, 0
	},
	{
		"ROYAL ROBE",
		ROYALROBE,
		LTREASURE,
		0, 0, 0
	},
	{
		"SNORKEL",
		SNORKEL,
		LTREASURE,
		0, 0, 0
	},
	{
		"MIRROR SHIELD",
		MIRRORSHIELD,
		LTREASURE,
		0, 0, 0
	},
	{
		"UNICORN HORN",
		UNICORNHORN,
		LTREASURE,
		0, 0, 0
	},
	{
		"X-RAY GLASSES",
		XRAYGLASSES,
		LTREASURE,
		0, 0, 0
	},
	{
		"PANDORAS BOX",
		PANDORASBOX,
		LTREASURE, 
		0, 0, 0
	},
	{
		"EXCALIBUR",
		EXCALIBUR,
		LTREASURE,
		0, 0, 0
	},
	{
		"SANDS OF TIME",
		SANDSOFTIME,
		LTREASURE,
		0, 0, 0
	},
	{
		"HALO",
		HALO,
		LTREASURE,
		0, 0, 0
	},
	{
		"WARP STONE",
		WARPSTONE,
		ITEM,
		0, 0, 0
	}
};

uint8_t validEnemies[5][10] = 
{
	2,	PELLET, HERMIE, 0, 0, 0, 0, 0, 0, 0,
	3,	PELLET, HERMIE, PICKLEMAN, GARGOYLE, 0, 0, 0, 0, 0,
	7,	PELLET, GARGOYLE, HERMIE, PICKLEMAN, GHOST, FANGOLA, 0, 0, 0,
	6,	GARGOYLE, PICKLEMAN, SKELETON, GHOST, FANGOLA, MIMIC, 0, 0, 0,
	7,	GARGOYLE, PICKLEMAN, DRAGON, SKELETON, GHOST, FANGOLA, MIMIC, 0, 0
};

uint8_t validEquipment[5][8] =
{
	3, 0, 1, 6, 0,	0, 0, 0,
	4, 0, 1, 6, 7,	0, 0, 0, 
	7, 0, 1, 2,	6, 7,	8, WARPSTONE_POS,
	7, 2, 3, 4,	7, 8,	9, WARPSTONE_POS,
	6, 2, 3, 4,	8, 9,	WARPSTONE_POS, 0
};

