#ifndef _globals_h_
#define _globals_h_

#include <vmgp.h>
#include "unit.h"
#include "res.h"
#include "inventoryitem.h"

//***These globals are needed by the program.
//Don't touch these.***
#define NUM_RESOURCES			YPOTION + 2
#define NUM_LEVELS				5
#define SPRITE_WIDTH			16
#define SPRITE_HEIGHT			16
#define MENUBOX_START_TEXT_X	11
#define MENUBOX_START_TEXT_Y	11
#define NUM_TREASURES			20
#define TEXTBOX_BORDER			5
#define TILESIZE				16
#define MAX_SPRITES				30

#define ARMOR_START		0
#define ARMOR_END		4
#define WEAPON_START	5
#define WEAPON_END		9
#define ACCESSORY_START	10
#define ACCESSORY_END	14
#define SCROLL_START	15
#define SCROLL_END		20
#define ITEM_START		21
#define ITEM_END		28
#define LTREASURE_START	29
#define LTREASURE_END	48
#define WARPSTONE_POS	49
#define INV_START_X		13
#define INV_START_Y		17
#define INV_SEP_X		23
#define INV_SEP_Y		23
#define INV_TLCORNERX	8
#define INV_TLCORNERY	22
#define INV_TEXT_Y		72

extern uint32_t seeds[NUM_LEVELS];	

//All the items in the collection
extern uint8_t treasurecollection[NUM_TREASURES];
extern UNIT sprites[MAX_SPRITES];
extern uint16_t		width, height;		//Dimensions of the screen
extern uint8_t		canVibrate;			//0 if disabled, 1 if enabled
extern uint8_t		doesVibrate , 
					sound ;			//0 if disabled, 1 if enabled
extern uint8_t		level;
extern int16_t mapX, mapY;
extern char* legendaryTreasures[];
extern UNIT unitstats[];
extern INVENTORYITEM items[];
extern INVENTORYITEM inventory[];
extern uint8_t validEnemies[5][10];
extern uint8_t validEquipment[5][8];
extern uint8_t* map;
extern uint8_t floor1, floor2;
extern uint16_t musicres[];
extern uint8_t* music;
extern uint8_t playerIsDead;
extern uint8_t debug;
extern uint8_t vanish;
extern uint8_t log;
extern uint8_t demo;
extern uint32_t demoTime;

//***These are variables that can change***
//Speed of the ghost and its animation in the introduction
#define GHOST_SPEED					4
#define GHOST_ANIMATION_RATE		100
//Maximum size of the map in tiles
#define MAP_SIZE_X					30
#define MAP_SIZE_Y					30
//Rate at which the player & enemies move
#define SCROLL_SPEED				4
//Num of legendary/normal treasures per floor
#define NUM_LTREASURES_PER_FLOOR	2
#define NUM_TREASURES_PER_FLOOR		4
//Minimum and maximum number of enemies per floor
#define MIN_ENEMIES_PER_FLOOR		4
#define MAX_ENEMIES_PER_FLOOR		5
//Lenght of status effects
#define POISON_LENGTH				25
#define CONFUSION_LENGTH			15
#define POWERUP_LENGTH				25
//Rate at which sprites animate (lower the number, the faster)
#define ANIMATION_RATE				200
//Number of frames of animation each sprite has
#define NUM_FRAMES					3
//Maximum # of items in inventory
#define MAX_INVENTORY				8
//Min & max # of traps per floor
#define MIN_TRAPS_PER_FLOOR			1
#define MAX_TRAPS_PER_FLOOR			2
//Length of a flash
#define FLASH_LENGTH				50
//How fast/how many times sprites flicker before dying
#define DEATH_FLASH_LENGTH			50
#define DEATH_FLASH_TIMES			6
//How high the chance is for Daryl/An enemy to miss
#define PERCENT_CHANGE_TO_MISS		5
//How many turns until a monster respawns
#define TURNS_TO_RESPAWN			60

#define DEMO_TIME 3

#define HELP "Help Daryl collect all 20 legendary treasures from the Magic Dungeon.  Each time you play the dungeons are different! Each floor has its own 4 unique treasures. You can only hold 8 things in your inventory as well so manage wisely. Use the joystick or the numpad to manuever daryl through the dungeon. Press * to quit the game and press 2 from the main menu to continue it later. Press 5 to access your inventory.  Once in your inventory press 5 on the selected to item to see what you can do with it. Only one weapon, armor, and accessory can be equipped at one time!  Walk into monsters to battle with them but watch your HP in the upper right box. If it reaches zero, the game is over and you lose your currently held treasures and saved game! If you escape from the dungeon the legendary treasures you held will be added to your collection permanently! To clear the collection, enter the collection from the main menu and press *.  For a more detailed explanation of monsters and items, or if you have questions please visit www.spookytornado.com for support!"

#endif
