#include "introduction.h"

#include <vmgp.h>
#include "globals.h"
#include "res.h"
#include "app.h"
#include "utility.h"

void introduction()
{
	uint8_t* resources[NUM_RESOURCES];
	initResources(resources, NUM_RESOURCES);

	//Load all the necessary resources
	LoadPackedRes(GHOST1, GHOST1_UNPACKED_SIZE, &resources[GHOST1]);
	LoadPackedRes(GHOST2, GHOST2_UNPACKED_SIZE, &resources[GHOST2]);
	LoadPackedRes(LOGO, LOGO_UNPACKED_SIZE, &resources[LOGO]);

	//The main loop that will move the ghost and redraw the screen
	uint32_t timeStart = vGetTickCount();
	uint32_t ghostX = width, ghostFrame = 0;

	uint32_t ghostAnim = vGetTickCount();
	while (vGetTickCount() - timeStart < 3000)
	{
		vClearScreen(vRGB(255,255,255));
		vDrawObject(width/2-LOGO_WIDTH/2, height/2-LOGO_HEIGHT/2, resources[LOGO]);

		ghostX -= GHOST_SPEED;
		if (ghostX < width/2 - GHOST1_WIDTH/2) ghostX = width/2 - GHOST1_WIDTH/2;
		
		if (vGetTickCount() - ghostAnim > GHOST_ANIMATION_RATE)
		{
			ghostAnim = vGetTickCount();
			ghostFrame = !ghostFrame;
		}

		vDrawObject(ghostX, height/2-LOGO_HEIGHT/2, resources[GHOST1 + ghostFrame]);

		vFlipScreen(1);
	}

	freeAllResources(resources, NUM_RESOURCES);

}
