#include "introduction.h"

#include <vmgp.h>
#include "globals.h"

void introduction()
{
	uint8_t* resources[NUM_RESOURCES];
	initResources(resources, NUM_RESOURCES);

	//Load all the necessary resources
	LoadPackedRes(GHOST1, GHOST1_UNPACKED_SIZE, &resources[GHOST1]);
	LoadPackedRes(GHOST2, GHOST2_UNPACKED_SIZE, &resources[GHOST2]);
	LoadPackedRes(LOGO, LOGO_UNPACKED_SIZE, &resources[LOGO]);

	//The main loop that will move the ghost and redraw the screen
	uint32_t timeStart = vGetTickCount();
	uint32_t ghostX = width, ghostFrame = 0;
	while (vGetTickCount() - timeStart < 3000)
	{
		vClearScreen(0);
		vDrawObject(0, 0, resources[LOGO]);

		ghostX -= GHOST_SPEED;
		if (ghostX < width/2 - GHOST1_WIDTH/2) ghostX = width/2 - GHOST1_WIDTH/2;
		
		if (ghostFrame == 0)
		{
			vDrawObject(ghostX, 0, resources[GHOST1]);
			ghostFrame = 1;
		}
		else
		{
			vDrawObject(ghostX, 0, resources[GHOST2]);
			ghostFrame = 0;
		}
		vFlipScreen(1);
	}

	freeAllResources(resources, NUM_RESOURCES);

}
