import javax.microedition.lcdui.*;
import javax.microedition.midlet.*;
import java.util.*;

public class FallingNumber
{
	public String number = new String();
	public String selection = new String(); //How much of the number has been typed by the user
	public int speed;
	public int x, y;
	public int red, green, blue; //Color
	
	Random rnd = new Random();

	static private int numberColors[][][] = { {	//Blue background components
												{255, 0, 0},
												{0, 0, 0},
												{255, 255, 0},
												{255, 0, 255},
												{0, 80, 20},
												
											  },
											  { //Orange background components
											  	{0, 0, 0},
											  	{255, 0, 0},
											  	{0, 80, 20},
											  	{0, 0, 255},
											  	{255, 0, 255},
											  	
											  },
											  { //Purple background components
											  	{0, 0, 0},
											  	{255, 0, 0},
											  	{0, 80, 20},
											  	{0, 0, 255},
											  	{100, 100, 0},
											  	
											  },
											  { //Black background components
											  	{255, 255, 255},
											  	{255, 0, 0},
											  	{0, 255, 0},
											  	{0, 0, 255},
											  	{255, 0, 255},
											  	
											  }
											 };
												
																	
	public int rand() { return Math.abs(rnd.nextInt()); }
	String numberToString(int n )
	{
		if (n <= 9 || NumberDropCanvas.level < 11 )
			return ("" + n);
		else if (n == 10)
			return "*";
		else if (n == 11)
			return "#";
		else return "";
	}
	
	public FallingNumber()
	{
		//Most number streams (80%) should only have one number, but sometimes larger strings will fall
		if (rand() % 100 < 80 || NumberDropCanvas.level < 6)
		{
			number = numberToString( rand()%12 );
		}
		else
		{
			//No falling number may have more than 3 characters
			if (NumberDropCanvas.level > 5 && NumberDropCanvas.level < 16)
			{
				for (int i = 0; i < 2; i++)
					number += numberToString( rand()%12 );
			}
			else
			{
				for (int i = 0; i < 2 + rand()%2; i++)
					number += numberToString( rand()%12 );
			}
			
		}
		
		y = -15;
		
		//Set a random color, making sure it's not too close to the
		//background color
		int color = rand()%numberColors[0].length;
		if (NumberDropCanvas.level % 20 < 6)
		{
			red = numberColors[0][color][0];
			green = numberColors[0][color][1];
			blue = numberColors[0][color][2];
		}
		else if (NumberDropCanvas.level % 20 < 11)
		{
			red = numberColors[1][color][0];
			green = numberColors[1][color][1];
			blue = numberColors[1][color][2];
		}
		else if (NumberDropCanvas.level % 20 < 16)
		{
			red = numberColors[2][color][0];
			green = numberColors[2][color][1];
			blue = numberColors[2][color][2];
		}
		else
		{
			red = numberColors[3][color][0];
			green = numberColors[3][color][1];
			blue = numberColors[3][color][2];
		}
		
	}
	
	//Returns if the entire number has been selected
	public boolean update(String selection)
	{
		if (selection.charAt(0) == number.charAt(this.selection.length()))
			this.selection += selection;
		else
			this.selection = "";
			
		return (this.selection.compareTo(number) == 0);
	}
	
	public void paint(Graphics g)
	{
		if (NumberDropCanvas.isColor == 1 )	g.setColor(red,green,blue);
		else							g.setColor(0,0,0);
		
		g.drawString(number, x, y, Graphics.TOP | Graphics.LEFT);
		
		if (NumberDropCanvas.isColor == 1 ) g.setColor(255,0,0);
		else						  g.setColor(0,0,0);
		
		g.drawString(selection, x, y, Graphics.TOP | Graphics.LEFT);
	}
}
