import javax.microedition.lcdui.*;
import javax.microedition.midlet.*;
import javax.microedition.rms.*;

import java.util.*;
import java.io.*;

import com.nokia.mid.sound.Sound;

public class NumberDrop extends MIDlet
{
	private NumberDropCanvas canvas;
	private Display display;
	
	public NumberDrop()
	{
		canvas = new NumberDropCanvas();
		display = Display.getDisplay(this);
	}
	
	public void startApp() throws MIDletStateChangeException
	{
		display.setCurrent(canvas);
	}
	
	public void pauseApp(){}
	public void destroyApp(boolean unconditional){}
}

class NumberDropCanvas extends Canvas implements Runnable
{
	Random 		rnd = new Random();
	RecordStore rs;
	
	//Gamestate variables
	private final int GAMESTATE_TITLE 		= 0;	
	private final int GAMESTATE_GAME 		= 1;	
	private final int GAMESTATE_LEVELSELECT = 2;
	private final int GAMESTATE_HIGHSCORES 	= 3;
	private final int GAMESTATE_CREDITS 	= 4;	
	private final int GAMESTATE_PAUSE 		= 5;
	private final int GAMESTATE_HELP		= 6;	
	private final int GAMESTATE_MENU		= 7;	
	private final int GAMESTATE_ENTERINGHS	= 8;
	private final int GAMESTATE_GAMEOVER	= 9;	
	private final int GAMESTATE_LEVELUP		= 10;	
	private final int GAMESTATE_ENDING		= 11;	
	private final int GAMESTATE_LOGO		= 12;
	private int gameState = GAMESTATE_LOGO;

	public static final int BACKGROUND_BLUE = 0;
	public static final int BACKGROUND_ORANGE = 1;
	public static final int BACKGROUND_PURPLE = 2;
	public static final int BACKGROUND_BLACK = 3;
		
	//All the various miscellaneous images
	Image 	imageBonusTime,
			imageBottom,
			imageEnding,
			imageGameOver,
			imageLevelUp,
			imageMenu,
			imageTitle,
			imagePause,
			imageLogo;
	
	//The template sprites
	Sprite 	templateMen[],
			templateClouds[],
			templateDeath,
			templateEnd;
	
	Sound	soundNumber,
			soundDeath;
			
	//Variables that change throughout the course of the game
	long score;
	static int level;
	int matches;
	long addTimer;
	int bonusTime;
	long bonusTimeStart;
	int numSeconds;
	int numPeopleToShow;
	
	Vector vMen = new Vector();
	Vector vClouds = new Vector();
	Vector vNumbers = new Vector();
	Vector vRecords = new Vector();
	Vector vDyingMen = new Vector();
	Vector vEndingMen = new Vector();
	
	//Gamestate specific variables
	String initials 	= new String();		//ENTERINGHS
	char currChar		= 'A';
	String levelString	= new String();		//LEVELSELECT
	long timeBonusStart;
	int tempLevel = 1;
	int startHelp = 0;
	boolean soundOn = true;
	int speed = 0;
	
	//Variables that need to be set depending on what type of phone
	//is being used
	int 	manWidth 	= 12;
	int 	scoreX 		= 40, 	
			scoreY 		= 94;
	int 	levelX 		= 115, 	
			levelY 		= 94;
	int 	menuTitleY 	= 9;
	int		menuTextX 	= 5, 	
			menuTextY 	= 25;
	int 	cloudLine 	= 30;
	long	scoreCap	= 99999;
	int		frameRate	= 40;
	int		manEndWidth = 14;
	public static int isColor 		= 1;		//1 = true, 0 = false
			
	public NumberDropCanvas()
	{
		soundNumber = new Sound(233, 100);
		soundDeath = new Sound(370, 200);
		
		//Read in the phone-dependent data
		try
		{
			StreamTokenizer in = new StreamTokenizer(new DataInputStream(getClass().getResourceAsStream("/attributes.txt")));
			in.nextToken(); manWidth 	= (int)in.nval;
			in.nextToken(); scoreX 		= (int)in.nval;
			in.nextToken(); scoreY 		= (int)in.nval;
			in.nextToken(); levelX 		= (int)in.nval;
			in.nextToken(); levelY 		= (int)in.nval;
			in.nextToken(); menuTitleY 	= (int)in.nval;
			in.nextToken(); menuTextX 	= (int)in.nval;
			in.nextToken(); menuTextY 	= (int)in.nval;
			in.nextToken(); cloudLine 	= (int)in.nval;
			in.nextToken(); scoreCap 	= in.nval;
			in.nextToken(); frameRate 	= (int)in.nval;
			in.nextToken(); manEndWidth = (int)in.nval;
		}
		catch (Exception e)
		{
			System.out.println("Error reading attributes file: " + e.getMessage());
		}
		
		//Load the images
		try
		{	
			imageLogo		= Image.createImage("/graphics/logo" 		+ getWidth() + getHeight() + ".png");
			imageTitle		= Image.createImage("/graphics/title" 		+ getWidth() + getHeight() + ".png");
			imageBonusTime 	= Image.createImage("/graphics/bonustime" 	+ getWidth() + getHeight() + ".png");
			imageBottom 	= Image.createImage("/graphics/bottom" 		+ getWidth() + getHeight() + ".png");
			imageEnding 	= Image.createImage("/graphics/ending" 		+ getWidth() + getHeight() + ".png");
			imageGameOver 	= Image.createImage("/graphics/gameover" 	+ getWidth() + getHeight() + ".png");
			imageLevelUp	= Image.createImage("/graphics/levelup" 	+ getWidth() + getHeight() + ".png");
			imageMenu		= Image.createImage("/graphics/menuboxes" 	+ getWidth() + getHeight() + ".png");
		}		
		catch(Exception e)
		{
			System.out.println("Error loading graphics: " + e.getMessage());
		}
		
		//Load the template sprites to be used to create the real sprites
		templateMen = new Sprite[10];
		for (int i = 0; i < templateMen.length; i++)
			templateMen[i] = new Sprite("/graphics/man" + (i+1) + getWidth() + getHeight() + ".png", manWidth);
		templateClouds = new Sprite[3];
		for (int i = 0; i < templateClouds.length; i++)
			templateClouds[i] = new Sprite("/graphics/cloud" + (i+1) + getWidth() + getHeight() + ".png");
		templateDeath = new Sprite("/graphics/die" + getWidth() + getHeight() + ".png", manWidth);
		templateEnd = new Sprite("/graphics/manend" + getWidth() + getHeight() + ".png", manEndWidth);
		
		varsInit();
		
		new Thread(this).start();
	}
	
	public int rand() { return Math.abs(rnd.nextInt()); }
	
	public void generatePeople(int st)
	{
		for (int i = st; i < 10; i++)
		{
			Sprite s = new Sprite(templateMen[rand()%numPeopleToShow]);
			vMen.addElement(s);
			s.x = rand() % getWidth();
			s.y = getHeight() - imageBottom.getHeight() - s.height;
			s.timeDelay = 100 + rand() % 50;
			
			s.speed = rand() % 5 - 2;
			if (s.speed == 0) s.speed = 1;
			
			if (s.speed < 0)
			{
				s.startFrame = 0;
				s.currFrame = 0;
				s.endFrame = 3;
			}
			else
			{
				s.startFrame = 4;
				s.currFrame = 4;
				s.endFrame = 7;
			}
		}
	}
	
	public void varsInit()
	{
		score 		= 0;
		//gameState 	= GAMESTATE_TITLE;
		level		= tempLevel;
		matches		= 0;
		bonusTime	= 0;
		numSeconds	= 0;
		initials	= "";
		numPeopleToShow = 4;
		if (tempLevel > 5) numPeopleToShow = 6;
		if (tempLevel > 10) numPeopleToShow = 8;
		if (tempLevel > 15) numPeopleToShow = 10;
					
		
		addTimer 	= System.currentTimeMillis();
				
		//Add 10 man sprites to the array, randomly determining if they're pointing left or right
		vMen.removeAllElements();
		generatePeople(0);
				
		//Add some clouds to the scene
		vClouds.removeAllElements();
		int numClouds = rand () % 5 + 3;
		for (int i = 0; i < numClouds; i++)
		{
			vClouds.addElement(new Sprite(templateClouds[rand() % templateClouds.length]));
			((Sprite)vClouds.elementAt(i)).x = rand() % getWidth();
			((Sprite)vClouds.elementAt(i)).y = rand() % getHeight() - cloudLine;
			((Sprite)vClouds.elementAt(i)).speed = -1;
		}
		
		vNumbers.removeAllElements();
		vRecords.removeAllElements();
		vEndingMen.removeAllElements();
		
		for (int i = -2; i < 2; i++)
		{
			Sprite s = new Sprite(templateEnd);
			s.y = getHeight() - imageBottom.getHeight() - s.height;
			s.x = getWidth() / 2 + i * s.width;
			
			s.startFrame = (i + 2) * 2;
			s.endFrame = (i + 2) * 2 + 1;
			s.currFrame = s.startFrame +i%2;
			s.timeDelay = 200 + rand()%50;
			s.timeStart = System.currentTimeMillis();
			vEndingMen.addElement(s);
		}
			
	}
	
	public void updateNumbers(Graphics g)
	{
		int rate = 25;
		int addRate = 1200 - level * rate;
		if (addRate < 1200 - 25 * rate) addRate = 1200-25*rate;
		if (bonusTime > 0) addRate = 1200-25*rate;
		
		//Make a new number fall down if necessary
		if (System.currentTimeMillis() - addTimer >= addRate)
		{
			addTimer = System.currentTimeMillis();
			
			FallingNumber f = new FallingNumber();
			int numLength = 0;
			for (int i = 0; i < f.number.length(); i++)
				numLength += g.getFont().charWidth(f.number.charAt(i));
			f.x = rand()%(getWidth() - numLength);
			
			//Cap the speed at 3.
			f.speed = 1 + bonusTime;
						
			vNumbers.addElement(f);
		}
		
		//Update & draw the numbers
		for (int i = 0; i < vNumbers.size(); i++)
		{
			FallingNumber f = ((FallingNumber)vNumbers.elementAt(i));
			f.y += f.speed;
								
			//If the number crashes into the ground, kill a person and remove the number
			if (f.y + g.getFont().getHeight() > getHeight() - imageBottom.getHeight())
			{
				vNumbers.removeElementAt(i);
				if (soundOn) soundDeath.play(1);
							
				if (vMen.size() > 0)
				{
					Sprite s = new Sprite(templateDeath);
					s.currFrame = 0;
					s.startFrame = 0;
					s.endFrame = 4;
					s.speed = 0;
					s.x = ((Sprite)vMen.elementAt(0)).x;
					s.y = ((Sprite)vMen.elementAt(0)).y + ((Sprite)vMen.elementAt(0)).height - s.height;
					s.timeDelay = 100;
					s.timeStart = System.currentTimeMillis();
					
					vMen.removeElementAt(0);
					vDyingMen.addElement(s);
				}		
				
			}
			
			if (vMen.size() == 0 && vDyingMen.size() == 0)
				{
					if (bonusTime == 0)
						gameState = GAMESTATE_GAMEOVER;
					else
					{
						gameState = GAMESTATE_LEVELUP;
						bonusTime = 0;
						vNumbers.removeAllElements();
						
						generatePeople(0);
					}
				}
		}
		
		//Handle bonus time counter here too
		if (bonusTime == 1 && System.currentTimeMillis() - bonusTimeStart >= numSeconds * 1000)
		{
			numSeconds++;
			score += 5;
			if (score > scoreCap) score = scoreCap;
		}
		
		if (bonusTime == 1 && System.currentTimeMillis() - bonusTimeStart >= 30000)
		{
			if (numPeopleToShow < 10) numPeopleToShow += 2;
			
			bonusTime = 0;
			gameState = GAMESTATE_LEVELUP;
			score += 5000;
			if (score > scoreCap) score = scoreCap;
			
			generatePeople(vMen.size());
		}
		
	}
	
	public void paintNumbers(Graphics g)
	{
		for (int i = 0; i < vNumbers.size(); i++)
			((FallingNumber)vNumbers.elementAt(i)).paint(g);
	}
	
	public void updatePeople()
	{
		for (int i = 0; i < vMen.size(); i++)
		{
			Sprite s = ((Sprite)vMen.elementAt(i));
			
			s.x += s.speed;
			if (s.x + s.width < 0) s.x = getWidth();
			if (s.x > getWidth()) s.x = -s.width;
					
			s.animate();
			
		}
		
		for (int i = 0; i < vDyingMen.size(); i++)
		{
			Sprite s = ((Sprite)vDyingMen.elementAt(i));
						
			s.animate();
			if (s.currFrame == s.endFrame)
			{
				vDyingMen.removeElementAt(i);
				i--;
			}
		}	
	}
	
	public void paintPeople(Graphics g)
	{
		for (int i = 0; i < vMen.size(); i++)
			((Sprite)vMen.elementAt(i)).paint(g);
			
		for (int i = 0; i < vDyingMen.size(); i++)
			((Sprite)vDyingMen.elementAt(i)).paint(g);
	}
	
	public void paintBackground(Graphics g)
	{
		if (isColor == 1 )	
		{
			if (level % 20 < 6)
				g.setColor(0,255,255);
			else if (level % 20 < 11)
				g.setColor(255, 153, 0);
			else if (level % 20 < 16)
				g.setColor(255, 140, 250);
			else
				g.setColor(0,0,0);
			
		}
		else				
			g.setColor(255,255,255);
		
		g.fillRect(0,0,getWidth(),getHeight());
		
		//Update & Draw the clouds
		for (int i = 0; i < vClouds.size(); i++)
		{
			Sprite cloud = (Sprite)vClouds.elementAt(i);
			cloud.x += cloud.speed;
			
			if (cloud.x + cloud.width <= 0)
			{
				cloud.x = getWidth();
				cloud.y = rand() % getHeight() - cloudLine;
			}
			
			cloud.paint(g);
		}
			
		g.drawImage(imageBottom, 0, getHeight()-1, Graphics.BOTTOM | Graphics.LEFT);
		
		g.setColor(0,0,0);
		g.drawString("" + score, scoreX, scoreY, Graphics.BOTTOM | Graphics.LEFT);
		g.drawString("" + level, levelX, levelY, Graphics.BOTTOM | Graphics.LEFT);
	}
	
	public void run()
	{
		while (true)
		{
			long timeDelay = 1000/(frameRate-speed);
			long timeStart = System.currentTimeMillis();
			
			repaint();
			serviceRepaints();
			
			long timeEnd = System.currentTimeMillis();
			long timeDelta = timeEnd - timeStart;
			
			if (timeDelta < timeDelay)
				try
				{
					Thread.sleep(timeDelay - timeDelta);
				} catch (Exception e){}
		}
	}
	
	public void paint(Graphics g)
	{
		g.setFont(Font.getFont(Font.FACE_SYSTEM, Font.STYLE_PLAIN, Font.SIZE_SMALL));
		
		//This is where most of the game logic goes...
		switch(gameState)
		{
			case GAMESTATE_LOGO:
				g.setColor(255,255,255);
				g.fillRect(0,0,getWidth(),getHeight());
				g.drawImage(imageLogo, getWidth()/2, getHeight()/2, Graphics.HCENTER | Graphics.VCENTER);
			break;
			
			case GAMESTATE_TITLE:
				g.drawImage(imageTitle, 0, 0, Graphics.TOP | Graphics.LEFT);
			break;
			
			case GAMESTATE_GAME:
				paintBackground(g);					
				updatePeople();
				paintPeople(g);
				updateNumbers(g);
				paintNumbers(g);
				
			break;
			
			case GAMESTATE_GAMEOVER:
				paintBackground(g);
				paintPeople(g);
				paintNumbers(g);
 				g.drawImage(imageGameOver, getWidth()/2, getHeight()/2, Graphics.HCENTER | Graphics.VCENTER);
			break;
			
			case GAMESTATE_LEVELUP:
				paintBackground(g);
				paintPeople(g);
				paintNumbers(g);
				 if (bonusTime == 0 ) 	g.drawImage(imageLevelUp, getWidth()/2, getHeight()/2, Graphics.HCENTER | Graphics.VCENTER);
				 else					g.drawImage(imageBonusTime, getWidth()/2, getHeight()/2, Graphics.HCENTER | Graphics.VCENTER);
			break;
			
			case GAMESTATE_ENDING:
				g.drawImage(imageEnding, 0, 0, Graphics.TOP | Graphics.LEFT);
				
				for (int i = 0; i < vEndingMen.size(); i++)
				{
					Sprite s = (Sprite)vEndingMen.elementAt(i);
					s.animate();
					s.paint(g);
				}
				
			break;
			
			case GAMESTATE_LEVELSELECT:
				g.drawImage(imageMenu, 0, 0, Graphics.TOP | Graphics.LEFT);
				g.setColor(0,0,0);
				
				g.drawString("Level Select", getWidth()/2, menuTitleY, Graphics.TOP | Graphics.HCENTER);
				g.drawString("Use up/down to change", getWidth()/2, menuTextY, Graphics.TOP | Graphics.HCENTER);
				g.drawString("the level", getWidth()/2, menuTextY + g.getFont().getHeight(), Graphics.TOP | Graphics.HCENTER);
				g.drawString("" + tempLevel, getWidth()/2, menuTextY + 2 * g.getFont().getHeight(), Graphics.TOP | Graphics.HCENTER);
				g.drawString("Hit * to confirm", getWidth()/2, getHeight()-g.getFont().getHeight(), Graphics.BOTTOM | Graphics.HCENTER);
				
			break;
			case GAMESTATE_HIGHSCORES:
				//Draw the menu template
				g.drawImage(imageMenu, 0, 0, Graphics.TOP | Graphics.LEFT);
				g.setColor(0,0,0);
				
				g.drawString("High Scores", getWidth()/2, menuTitleY, Graphics.TOP | Graphics.HCENTER);
				for (int i = 0; i < vRecords.size(); i++)
				{
					String record = (String)vRecords.elementAt(i);
					String initials = record.substring(0,3);
					String score = record.substring(3);
					
					g.drawString("" + (i+1) + ") " + initials, menuTextX, menuTextY + i * g.getFont().getHeight(), Graphics.TOP | Graphics.LEFT);
					g.drawString(score, getWidth() - menuTextX, menuTextY + i * g.getFont().getHeight(), Graphics.TOP | Graphics.RIGHT);
				}
					
			break;
			case GAMESTATE_CREDITS:
				//Draw the menu template
				g.drawImage(imageMenu, 0, 0, Graphics.TOP | Graphics.LEFT);
				g.setColor(0,0,0);
				
				//Draw the text
				g.drawString("Credits", getWidth()/2, menuTitleY, Graphics.TOP | Graphics.HCENTER);
				String credits[] = { 	"Design:",
										"Dustin Hubbard",
										"Programming:",
										"Brian Sowers",
										"Producer:",
										"Jonathan Denmark" };
				for (int i = 0; i < credits.length; i++)
					g.drawString(credits[i], menuTextX, menuTextY + i * g.getFont().getHeight(), Graphics.TOP | Graphics.LEFT);
					
			break;
					
			case GAMESTATE_HELP:
				//Draw the menu template
				g.drawImage(imageMenu, 0, 0, Graphics.TOP | Graphics.LEFT);
				g.setColor(0,0,0);
				
				//Draw all the text
				g.drawString("Help", getWidth()/2, menuTitleY, Graphics.TOP | Graphics.HCENTER);
				String lines[] = { "Save the citizens of",
								   "Mobiletopia by using",
								   "the numbers on your ",
								   "phone.",
								   "Press the numbers",
								   "",
								   "(Hit down for more...)",
								   "that are falling to",
								   "destroy them. For",
								   "multiple numbers",
								   "press them in order",
								   "from left to right.",
								   "",
								   "(Hit down for more...)",
								   "You must get all",
								   "of the string correct",
								   "or you'll have to",
								   "repeat it. Every 5",
								   "rounds a Bonus Round",
								   "",
								   "(Hit down for more...)",
								   "will occur in which",
								   "the speed will double",
								   "and you will gain ",
								   "50 points a number!",
								   "Survive the",
								   "",
								   "(Hit down for more...)",
								   "entire round and gain",
								   "5000 points. After", 
								   "the bonus round you",
								   "will receive 10",
								   "citizens to continue",
								   "",
								   "(Hit down for more...)",
								   "your game with. After",
								   "round 25 this stops",
								   "occuring so good luck!",
								   "Any bugs, suggestions",
								   "or comments?",
								   "",
								   "(Hit down for more...)",
								   "E-mail",
								   "support@",
								   "spookytornado.com,",
								   "or visit our website ",
								   "spookytornado.com",
								   "", ""};
				int pos = 0;	
				for (int i = startHelp; i < startHelp + 7; i++, pos++)
				{
					g.drawString(lines[i], menuTextX, menuTextY + pos * g.getFont().getHeight(), Graphics.TOP | Graphics.LEFT);
				}
			break;
			case GAMESTATE_MENU:
				//Draw the menu template
				g.drawImage(imageMenu, 0, 0, Graphics.TOP | Graphics.LEFT);
				g.setColor(0,0,0);
				
				//Draw all the options
				String sSpeed = new String();
				if (speed == 0) sSpeed = "fast";
				if (speed == 10) sSpeed = "medium";
				if (speed == 20) sSpeed = "slow";
				
				g.drawString("Number Drop", 	getWidth()/2, menuTitleY, Graphics.TOP | Graphics.HCENTER);
				String options[] = { "1) Play",
									 "2) Level",
									 "3) High Scores",
									 "4) Help",
									 "5) Credits",
									 ((soundOn)?("6) Sound is On"):("6) Sound is Off")),
									 "7) Speed is " + sSpeed };
									 
				for (int i = 0; i < options.length; i++)
					g.drawString(options[i], menuTextX, menuTextY + i * g.getFont().getHeight(), Graphics.TOP | Graphics.LEFT);
					
			break;
			case GAMESTATE_ENTERINGHS:
				//Draw the menu template
				g.drawImage(imageMenu, 0, 0, Graphics.TOP | Graphics.LEFT);
				g.setColor(0,0,0);
				
				g.drawString("High Scores",		getWidth()/2, menuTitleY, Graphics.TOP | Graphics.HCENTER);
				
				int position = vRecords.size();
				int delta = 0;
				for (int i = 0; i < vRecords.size() && i < 4; i++)
				{
					String r = (String)vRecords.elementAt(i);
					String n = r.substring(0,3);
					long   s = Long.parseLong(r.substring(3));
					
					
					if (score > s && position > i)
						position = i;
						
					if (position <= i) delta = 1;
					else delta = 0;
					
					g.drawString("" + (i+1+delta) + ") " + n,
								 menuTextX,
								 menuTextY + (i+delta) * g.getFont().getHeight(),
								 Graphics.TOP | Graphics.LEFT);
					g.drawString("" + s,
								 getWidth() - menuTextX,
								 menuTextY + (i+delta) * g.getFont().getHeight(),
								 Graphics.TOP | Graphics.RIGHT);
		
				}
				if (position > 4) position = 4;
				g.drawString("" + (position+1) + ") " + initials + currChar,
							 menuTextX,
							 menuTextY + position * g.getFont().getHeight(),
							 Graphics.TOP | Graphics.LEFT);
				g.drawString("" + score,
							 getWidth() - menuTextX,
							 menuTextY + position * g.getFont().getHeight(),
							 Graphics.TOP | Graphics.RIGHT);
				
				g.drawString("Hit * to confirm",
							 getWidth() / 2,
							 getHeight() - g.getFont().getHeight(),
							 Graphics.BOTTOM | Graphics.HCENTER);
			break;
		}	
	}
	
	public char incCurrChar(char currChar, String valid)
	{
		for (int i = 0; i < valid.length() - 1; i++)
			if (currChar == valid.charAt(i))
				return valid.charAt(i+1);
				
		return valid.charAt(0);
		
	}
	
	public void keyPressed(int keyCode)
	{
		int key = 0;	
		
		//We want the game to progress even if there's no key action
		//for the given keyCode.  Some phones may break if
		//there isn't
		try
		{
			key = getGameAction(keyCode);
		} 
		catch(Exception e) {}
		
		switch(gameState)
		{
			case GAMESTATE_LOGO:
				gameState = GAMESTATE_TITLE;
			break;
			
			case GAMESTATE_CREDITS: case GAMESTATE_HIGHSCORES:
			case GAMESTATE_TITLE:
				gameState = GAMESTATE_MENU;
			break;
			
			case GAMESTATE_HELP:
				if (key == DOWN && startHelp < 42)
					startHelp += 7;
				else if (key == UP && startHelp > 0)
					startHelp -= 7;
				else
				{
					startHelp = 0;
					gameState = GAMESTATE_MENU;
				}
			break;
			
			case GAMESTATE_ENDING: 
				gameState = GAMESTATE_GAME;
			break;
			
			case GAMESTATE_LEVELUP:
				if (bonusTime == 1)
					bonusTimeStart = System.currentTimeMillis();
					
				gameState = GAMESTATE_GAME;
			break;
			
			case GAMESTATE_GAMEOVER:
				getRecords();
				gameState = GAMESTATE_MENU;
				
				if (vRecords.size() < 5)
					gameState = GAMESTATE_ENTERINGHS;
					
				for (int i = 0; i < vRecords.size(); i++)
				{
					String r = (String)vRecords.elementAt(i);
					long s = Long.parseLong(r.substring(3));
					if (score > s)
						gameState = GAMESTATE_ENTERINGHS;
					
				}
				
			break;
			
			case GAMESTATE_GAME:
				for (int i = 0; i < vNumbers.size(); i++)
				{
					FallingNumber f = (FallingNumber)vNumbers.elementAt(i);
					boolean destroy = false;
					if (keyCode >= KEY_NUM0 && keyCode <= KEY_NUM9)
						destroy = f.update("" + (keyCode - KEY_NUM0));
					else if (keyCode == KEY_POUND)
						destroy = f.update("#");
					else if (keyCode == KEY_STAR)
						destroy = f.update("*");
						
					if (destroy)
					{
						if (soundOn) soundNumber.play(1);
						
						if (bonusTime > 0)
							score += 50;
						else if (f.number.length() == 1)
							score += 5;
						else if (f.number.length() == 2)
							score += 25;
						else if (f.number.length() == 3)
							score += 50;
						else
							score += 5;
											
						if (score > scoreCap) score = scoreCap;
						vNumbers.removeElementAt(i);
						i--;
						
						if (bonusTime == 0)
						{
							matches++;
							//Increase the level if necessary
							if (matches == level * 10 || matches == 40)
							{
								matches = 0;
								if (level < 99)
								{ 
									level++;
									vNumbers.removeAllElements();
																
									if (level == 26)
									{
										gameState = GAMESTATE_ENDING;
										generatePeople(vMen.size());
									}
									else if (level == 6 || level == 11 ||
											 level == 16 || level == 21)
									{
										bonusTime = 1;
										gameState = GAMESTATE_LEVELUP;
									}
									else
										gameState = GAMESTATE_LEVELUP;
								}
								
							}
						}
												
					}
				}
				
			break;
			case GAMESTATE_LEVELSELECT:
				if (key == UP && tempLevel < 25)
					tempLevel++;
				if (key == DOWN && tempLevel > 1)
					tempLevel--;
				if (keyCode == KEY_STAR)
					gameState = GAMESTATE_MENU;
					
				
			break;
			
			
			case GAMESTATE_MENU:
				if (keyCode == KEY_NUM1)
				{
					varsInit();
					gameState = GAMESTATE_GAME;
				}
				if (keyCode == KEY_NUM2)
				{
					gameState = GAMESTATE_LEVELSELECT;
				}
				if (keyCode == KEY_NUM3)
				{
					getRecords();
					gameState = GAMESTATE_HIGHSCORES;
				}
				if (keyCode == KEY_NUM4)
				{
					gameState = GAMESTATE_HELP;
				}
				if (keyCode == KEY_NUM5)
				{
					gameState = GAMESTATE_CREDITS;
				}
				if (keyCode == KEY_NUM6)
				{
					soundOn = !soundOn;
				}
				if (keyCode == KEY_NUM7)
				{
					if (speed == 0)
						speed = 10;
					else if (speed == 10)
						speed = 20;
					else
						speed = 0;
				}
				
			break;
			case GAMESTATE_ENTERINGHS:
				if (keyCode == KEY_NUM1)
					currChar = incCurrChar(currChar, " ");
				else if (keyCode == KEY_NUM2)
					currChar = incCurrChar(currChar, "ABC");
				else if (keyCode == KEY_NUM3)
					currChar = incCurrChar(currChar, "DEF");
				else if (keyCode == KEY_NUM4)
					currChar = incCurrChar(currChar, "GHI");
				else if (keyCode == KEY_NUM5)
					currChar = incCurrChar(currChar, "JKL");
				else if (keyCode == KEY_NUM6)
					currChar = incCurrChar(currChar, "MNO");
				else if (keyCode == KEY_NUM7)
					currChar = incCurrChar(currChar, "PQRS");
				else if (keyCode == KEY_NUM8)
					currChar = incCurrChar(currChar, "TUV");
				else if (keyCode == KEY_NUM9)
					currChar = incCurrChar(currChar, "WXYZ");
				else if (keyCode == KEY_NUM0)
					currChar = incCurrChar(currChar, "OPR");
				else if (keyCode == KEY_STAR)
				{
					initials += currChar;
					if (initials.length() >= 3)
					{
						//Save high score
						saveRecords();	
						gameState = GAMESTATE_MENU;
					}
				}
			break;
		}
	}
	
	public void saveRecords()
	{
		try
		{
			
			RecordStore.deleteRecordStore("numberdrophs");
			rs = RecordStore.openRecordStore("numberdrophs", true);
			
			//Insert the new record into the record vector
			boolean wasAdded = false;
			for (int i = 0; i < vRecords.size(); i++)
			{
				if (score > Long.parseLong( ((String)vRecords.elementAt(i)).substring(3) ))
				{
					vRecords.insertElementAt(initials + score, i);
					wasAdded = true;
					break;
				}
				if (score == Long.parseLong( ((String)vRecords.elementAt(i)).substring(3) ) && i != 4)
				{
					vRecords.insertElementAt(initials + score, i);
					wasAdded = true;
					break;
				}
			}
			if (vRecords.size() == 0 || !wasAdded)
			{
				vRecords.addElement(initials + score);
			}
						
			//Save all the valid records
			for (int i = 0; (i < vRecords.size()) && (i < 5); i++)
			{
				String s = (String)vRecords.elementAt(i);
				byte buffer[] = new byte[s.length()];
				for (int j = 0; j < buffer.length; j++)
					buffer[j] = (byte)s.charAt(j);
			
				rs.addRecord(buffer, 0, buffer.length);
			
			}
			
			rs.closeRecordStore();
		} 
		catch(Exception e)
		{
			System.out.println("Error saving high score: " + e.getMessage());
		}
	}
	
	public void getRecords()
	{
		try
		{
			vRecords.removeAllElements();
			
			rs = RecordStore.openRecordStore("numberdrophs", true);
			
			for (int i = 1; i <= rs.getNumRecords(); i++)
			{
				byte buffer[] = new byte[rs.getRecordSize(i)];
				rs.getRecord(i, buffer, 0);
				
				String hs = new String();
				for (int j = 0; j < buffer.length; j++)
					hs += (char)buffer[j];	
				
				vRecords.addElement(hs);
			}
			
			rs.closeRecordStore();
			
		}
		catch (Exception e)
		{
			System.out.println("Error loading message store: " + e.getMessage());
		}
	}
	
}
