import java.io.*;

public class StreamTokenizer
{
	StringBuffer stringBuffer = new StringBuffer();
	
	long nval;
	String sval = new String();
	int type;
	
	StreamTokenizer(DataInputStream in)
	{
		//Read the entire input stream into a string buffer so it
		//can be parsed properly
		try
		{
			byte b = 0;
			b = in.readByte();
			while (b != -1)
			{
				stringBuffer.append((char)b);
				b = in.readByte();
			}
			
		} catch (Exception e){}
	}
	
	//Determine if a string is a valid integer so that no exceptions
	//will be thrown when going to the next token
	boolean isInteger(String s)
	{
		String validNumbers = "-0123456789";
		

		for(int i = 0; i < s.length(); i++)
		{
			if (s.charAt(i) == '-' && i != 0)
				return false;
				
			if (s.charAt(i) < '0' || s.charAt(i) > '9')
				return false;
		}
		
		return true;
		
	}
	
	//Progress to the next token, and store the result in nval and sval
	//nval will be 0 if the token is not a valid number
	boolean nextToken()
	{
		sval = "";
		
		//Cut off any whitespace within the buffer
		String temp = stringBuffer.toString();
		stringBuffer = new StringBuffer(temp.trim());
		
		//Return false if there are no more tokens left to be parsed
		if (stringBuffer.length() <= 0)
			return false;
		
		//Parse a token from the string buffer
		while (stringBuffer.length() > 0 &&
			   stringBuffer.charAt(0) != (byte)(' ') &&
			   stringBuffer.charAt(0) != (byte)10 &&
			   stringBuffer.charAt(0) != (byte)13)
			   {
			   		sval += stringBuffer.charAt(0);
			   		stringBuffer.deleteCharAt(0);
			   }
		
		//If the string is a valid integer, put that integer in nval
		if (isInteger(sval))
			nval = Long.parseLong(sval);
		else
			nval = 0;
			
		return true;
	}
	
}
