#include <vmgp.h>
#include <vstream.h>
#include "numberdrop.h"
#include "font.h"
#include "game.h"

void titleScreen()
{
	vDrawObject(0,0,&TITLE);
	vFlipScreen(1);
	while(!vGetButtonData()){}
	while(vGetButtonData()){}
}

void highScore()
{
	displayHiScores(1);
}

void credits()
{
	vClearScreen(VMGP_BLACK);
	vDrawObject(0,0,&MENUBOX);

	printMain(26,6,"CREDITS",VMGP_BLACK);
	printMain(5,20,"Design:",VMGP_BLACK);
	printMain(5,29,"Dustin Hubbard",VMGP_BLACK);
	printMain(5,38,"Programming:",VMGP_BLACK);
	printMain(5,47,"Austin Russell",VMGP_RED);
	printMain(5,56,"Producer:",VMGP_BLACK);
	printMain(4,65,"Jonathan",VMGP_BLACK);
	printMain(56,65,"Denmark",VMGP_BLACK);

	vFlipScreen(1);

	while(!vGetButtonData()){}
	while(vGetButtonData()){}
}

void drawMainMenu(uint8_t lvl)
{
	uint8_t levelst[2];
	vitoa(lvl, levelst, 2, '0'); 

	vDrawObject(0,0,&MENUBOX);
	
	printMain(22,6,"MAIN MENU",VMGP_BLACK);
	printMain(5,20,"1.Start",VMGP_BLACK);
	printMain(5,29,"2.Level",VMGP_BLACK);
		printMain(53,29,levelst,VMGP_BLACK);
	printMain(5,38,"3.High Score",VMGP_BLACK);
	printMain(5,47,"4.Credits",VMGP_BLACK);
	printMain(5,56,"5.Help",VMGP_BLACK);
	printMain(5,65,"6.Exit",VMGP_BLACK);

	vFlipScreen(1);
}

uint8_t mainMenu()
{	
	// very helpful help message
	const char helpmsg[300]="this help message box is not very helplful because i cannot see how it will actually look on the phone";

	int8_t lvl=1;
	uint8_t keys;

	while(1)
	{
		drawMainMenu(lvl);
		keys=vScanKeys();

		switch(keys)
		{
		case '1': game(lvl); return 0;
		case '2':
			if(lvl==25) lvl=1;
			else lvl++;
			break;
		case '3': highScore(); break;
		case '4': credits(); break;
		case '5': vMsgBox(VMB_TITLE,helpmsg,"Help Yourself"); break;
		case '6': writeHiScores(); return 1;
		default: break;
		}
	}
}

int main(void)
{
	readHiScores();
	vSetDisplayWindow(101,80);
	vSetClipWindow(0,0,101,80);
	titleScreen();
	vClearScreen(vRGB(0,0,0));
	while(!mainMenu()){}
	return 1;
}
