# *****************************************
# NAME: makefile
# PROJECT: numberdrop
# DATE: 2003-05-20
# *****************************************

# FLAGS
#
# Use g to enable debugging
# Add fvstudio to enable Double click on error in Visual Studio
CFLAGS = -O2 -fvstudio

# OBJECT FILES
OBJS = res.o font.o game.o numberdrop.o

all: numberdrop.mpn

# RESOURCE
res.o: res.txt
	morc -v res.txt

# COMPILER
.c.o:
	pip-gcc -c $(CFLAGS) -o $@ $<

# LINKER
#
# -mstack = 512 - This is the desired STACK size
# -mdata = 10000 - This is the desired HEAP size. This is the memory
# used when doing memory allocations.
#
# Note: remove s if you want to use the debugger.
numberdrop.mpn: $(OBJS)
	pip-gcc -o $@ $(OBJS) -mstack=2048 -s -ldatacert