#include "title.h"

#include <vmgp.h>
#include "res.h"
#include "globals.h"
#include "utility.h"
#include "app.h"

void title()
{
	if (sound)
	{
		LoadPackedRes(MTITLE, MTITLE_UNPACKED_SIZE, &music);
		vPlayResource(music, MTITLE_UNPACKED_SIZE, SOUND_TYPE_MIDI );
	}

	uint8_t* resources[NUM_RESOURCES];
	initResources(resources, NUM_RESOURCES);

	LoadPackedRes(TITLE, TITLE_UNPACKED_SIZE, &resources[TITLE]);

	vClearScreen(0);
	vDrawObject(width/2-TITLE_WIDTH/2, height/2-TITLE_HEIGHT/2, resources[TITLE]);
	vFlipScreen(1);

	while (!keyPress('5'));

	freeAllResources(resources, NUM_RESOURCES);

	if (sound)
	{
		vDisposePtr(music);
		music = NULL;
	}
}
