#ifndef _unit_h_
#define _unit_h_

#define PLAYER		0
#define ENEMY		1
#define TREASURE	2
#define STAIRS_UP	3
#define STAIRS_DOWN	4

//Structure to contain information about both sprites and treasures
typedef struct _unit_
{

	//Identifier to tell the specifics of this sprite (what type of sprite it is)
	//This is used for AI and item acquisition and such
	uint8_t id;

	//The type of unit this is
	uint8_t	type;

	char name[15];

	uint8_t isAlive, isVisible;

	//Position
	int32_t x, y;

	//Basic stats
	int16_t	hp;
	uint8_t	strength, 
			defense, 
			statusTimePoison, statusTimeConfusion, statusTimePowerup; 

	//Animation information so that the animation is performed correctly
	int8_t frame;
	uint32_t animationCounter;

	int16_t flag, flag2, flag3,
			equippedWep, equippedArm, equippedAcc;	//Used only for the player


} UNIT;

#endif
