#include "utility.h"

int32_t LoadPackedRes(uint16_t res_id,uint16_t dst_size,uint8_t**ptrDest)
{	
	int32_t		handle,size;
 	
	handle = vResOpen(NULL,res_id);

	*ptrDest = vNewPtr(dst_size);
	size = vDecompress(NULL, *ptrDest, handle, 1024);
	vStreamClose(handle);
	return size;
}
void blit(int16_t x, int16_t y,
			 int16_t sx, int16_t sy,
			 int16_t sw, int16_t sh,
			 void *object, uint16_t prevSX, uint16_t prevSY)
{
	if (x < 0)
	{
		sx = -x;
		sw = sw + x;
		x = 0;
	}
	if (y < 0)
	{
		sy = -y;
		sh = sh + y;
		y = 0;
	}
	if (x + sw - 1 > prevSX)
	{
		sw = prevSX + 1 - x;
	}
	if (y + sh - 1 > prevSY)
	{
		sh = prevSY + 1 - y;
	}

	if (sw == 0 || sh == 0) return;
	if (x + sw < 0 || y + sh < 0) return;
	if (x > prevSX || y > prevSY) return;
	
	vSetClipWindow(x, y, x + sw - 1, y + sh - 1);
	vDrawObject(x - sx, y - sy, object);
	vSetClipWindow(0, 0, prevSX, prevSY);

}

uint8_t tokenize(char *string, char buffer[][15])
{
	
	uint8_t i, i2 = 0;
	uint8_t currToken = 0;
	for (i = 0; i < vStrLen(string); i++)
	{
		if (string[i] == ' ')
		{
			buffer[currToken][i2] = '\0';
			currToken++;
			i2 = 0;
		}
		else
		{
			buffer[currToken][i2] = string[i];
			i2++;
		}
	}

	buffer[currToken][i2] = '\0';
	return currToken + 1;	
}

void waitForKeyPress()
{
	while (!vScanKeys() && !vGetButtonData());
	while (vScanKeys() || vGetButtonData());
}

uint8_t keyPress(char key)
{
	if (vTestKey(key))
	{
		while (vTestKey(key));
		return 1;
	}

	return 0;
}

uint8_t buttonPress(uint32_t button)
{
	if (vGetButtonData() & button)
	{
		while (vGetButtonData() & button);
		return 1;
	}

	return 0;
}

uint16_t printWordWrap(char* string, uint16_t textX, uint16_t textY, uint16_t extreme, uint16_t fontWidth, uint16_t fontHeight)
{
	uint16_t left = textX;

	char buffer[30][15];
	uint8_t numTokens = tokenize(string, buffer);
	
	uint8_t token;
	for (token = 0; token < numTokens; token++)
	{
		if (textX + fontWidth * vStrLen(buffer[token]) > extreme)
		{
			textX = left;
			textY += fontHeight;
		}

		vPrint(MODE_TRANS, textX, textY, buffer[token]);
		textX += fontWidth * (vStrLen(buffer[token]) + 1);
	}

	return textY;
}

void sleep(uint32_t milli)
{
	uint32_t start = vGetTickCount();
	while (vGetTickCount() - start < milli);
}

void flash(int32_t color, uint32_t time)
{
	vClearScreen(color);
	vFlipScreen(1);

	uint32_t start = vGetTickCount();
	while (vGetTickCount() - start < time);
}
