#include "victory.h"
#include "globals.h"
#include "app.h"
#include "res.h"

void victory(uint8_t* resources[], uint8_t nTreasures)
{
	if (sound)
	{
		vDisposePtr(music);
		LoadPackedRes(MVICTORY, MVICTORY_UNPACKED_SIZE, &music);
		vPlayResource(music, MVICTORY_UNPACKED_SIZE, SOUND_TYPE_MIDI);
	}

	char buffer[5];
	vitoa(nTreasures, buffer, 0, ' ');

	vClearScreen(0);

	blit(width/2-SPRITE_WIDTH/2, SPRITE_HEIGHT*2, SPRITE_WIDTH*1, SPRITE_HEIGHT*4, SPRITE_WIDTH, SPRITE_HEIGHT,
		 resources[DARYL], width, height);

	vSetForeColor(vRGB(0,255,0));
	vPrint(MODE_TRANS, width/2 - (THEFONT_WIDTH*7)/2, SPRITE_HEIGHT, "VICTORY");

	vSetForeColor(vRGB(255,0,0));
	vPrint(MODE_TRANS, width/2 - (THEFONT_WIDTH*11)/2, SPRITE_HEIGHT*3+5 + 4*THEFONT_HEIGHT, "5.");
	vSetForeColor(vRGB(255,255,255));
	vPrint(MODE_TRANS, width/2 - (THEFONT_WIDTH*7)/2, SPRITE_HEIGHT*3+5+4*THEFONT_HEIGHT, "MAIN MENU");

	//Display # of treasures
	vPrint(MODE_TRANS, width/2 - (THEFONT_WIDTH*18)/2, SPRITE_HEIGHT*3+5, "YOU ESCAPED WITH ");
	vPrint(MODE_TRANS, width/2 - (THEFONT_WIDTH*18)/2 + THEFONT_WIDTH*17, SPRITE_HEIGHT*3+5, buffer);

	if (nTreasures > 1)
		vPrint(MODE_TRANS, width/2 - (THEFONT_WIDTH*19)/2, SPRITE_HEIGHT*3+5+THEFONT_HEIGHT, "LEGENDARY TREASURES");
	else
		vPrint(MODE_TRANS, width/2 - (THEFONT_WIDTH*18)/2, SPRITE_HEIGHT*3+5+THEFONT_HEIGHT, "LEGENDARY TREASURE");

	vFlipScreen(1);

	while(!keyPress('5'));

	if (sound) 
	{
		vDisposePtr(music);
		music = NULL;
	}
}
